/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

template < class Element >
IBoolean IABag < Element >::
operator == (IABag < Element > const& collection) const
{ if (numberOfElements () != collection.numberOfElements ())
    return False;

  ICursor *cursor1 = newCursor ();
  IBoolean result = True;
  for (cursor1->setToFirst ();
       cursor1->isValid ();
       setToNextDifferentElement (*cursor1)) {
    if (collection.numberOfOccurrences (elementAt (*cursor1)) !=
        numberOfOccurrences (elementAt (*cursor1))) {
      result = False;
      break;
    }
  }
  delete cursor1;
  return result;

}

template < class Element >
IBoolean IABag < Element >::
operator != (IABag < Element > const& collection) const
{ return ! operator == (collection);
}

