/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IABAG_H
#define _IABAG_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>

template < class Element >
class IABag : public virtual IAEqualityCollection < Element > {
public:

  virtual INumber        numberOfOccurrences         (Element const&) const = 0;

  virtual IBoolean       locateNext                  (Element const&, ICursor&)
                                               const = 0;

  virtual INumber        removeAllOccurrences        (Element const&) = 0;

  virtual INumber        numberOfDifferentElements   () const = 0;

  virtual IBoolean       setToNextDifferentElement   (ICursor&) const = 0;

  virtual IBoolean       operator ==                 (IABag < Element > const&) const;

  virtual IBoolean       operator !=                 (IABag < Element > const&) const;

  virtual void           unionWith                   (IABag < Element > const&) = 0;

  virtual void           intersectionWith            (IABag < Element > const&) = 0;

  virtual void           differenceWith              (IABag < Element > const&) = 0;

  virtual void           addUnion                    (IABag < Element > const&,
                                               IABag < Element > const&) = 0;

  virtual void           addIntersection             (IABag < Element > const&,
                                               IABag < Element > const&) = 0;

  virtual void           addDifference               (IABag < Element > const&,
                                               IABag < Element > const&) = 0;

protected:

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iabag.c>
#endif
#endif

#endif
