#ifndef _IACCEL_INL_
#define _IACCEL_INL_ 0
/*******************************************************************************
* FILE NAME: iaccel.inl                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in iaccel.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IACCEL_
  #undef  _IACCEL_INL_
  #define _IACCEL_INL_ 1
  #include <iaccel.hpp>
#endif

#ifndef _IRESLIB_
  #include <ireslib.hpp>
#endif

#if _IACCEL_INL_
  #define inline
#endif

/*------------------------------- IAccelerator -------------------------------*/
inline IWindow*  IAccelerator :: owner ( ) const
{
  return pwndClOwner;
}

inline IAccelerator&  IAccelerator :: set ( unsigned long accelResId )
{
  return set(IResourceId(accelResId));
}

inline IBase::Boolean  IAccelerator :: isSet ( ) const
{
  return isSetCl;
}

#endif // _IACCEL_INL_
