/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IAEQSEQ_H
#define _IAEQSEQ_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>
#include <iasqntl.h>

template < class Element >
class IAEqualitySequence :
  public virtual IAEqualityCollection < Element >,
  public virtual IASequentialCollection < Element > {
public:

  virtual INumber        numberOfOccurrences         (Element const&) const = 0;

  virtual IBoolean       locateNext                  (Element const&, ICursor&)
                                               const = 0;

  virtual INumber        removeAllOccurrences        (Element const&) = 0;

  virtual IBoolean       operator ==                 (IAEqualitySequence < Element > const&) const;

  virtual IBoolean       operator !=                 (IAEqualitySequence < Element > const&) const;

  virtual long           compare                     (IAEqualitySequence < Element > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

  virtual IBoolean       locateFirst                 (Element const&, ICursor&)
                                               const = 0;

  virtual IBoolean       locateLast                  (Element const&,
                                               ICursor&) const = 0;

  virtual IBoolean       locatePrevious              (Element const&,
                                               ICursor&) const = 0;

protected:

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iaeqseq.c>
#endif
#endif

#endif
