/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IAEQUAL_H
#define _IAEQUAL_H

#include <iglobals.h>
#include <icursor.h>
#include <iacllct.h>

template < class Element >
class IAEqualityCollection : public virtual IACollection < Element > {
public:

  virtual IBoolean       contains                    (Element const&) const = 0;

  virtual IBoolean       containsAllFrom             (IACollection <Element>
                                               const&) const;

  virtual IBoolean       locate                      (Element const&, ICursor&)
                                               const = 0;

  virtual IBoolean       locateOrAdd                 (Element const&) = 0;

  virtual IBoolean       locateOrAdd                 (Element const&,
                                               ICursor&) = 0;

  virtual IBoolean       remove                      (Element const&) = 0;

  virtual INumber        numberOfOccurrences         (Element const&) const = 0;

  virtual IBoolean       locateNext                  (Element const&, ICursor&)
                                               const = 0;

  virtual INumber        removeAllOccurrences        (Element const&) = 0;

protected:

  static IBoolean isContained (Element const&, void* env);
  static IBoolean isNotContained (Element const&, void* env);

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iaequal.c>
#endif
#endif

#endif
