/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IAKEY_H
#define _IAKEY_H

#include <iglobals.h>
#include <icursor.h>
#include <iacllct.h>

template < class Element, class Key >
class IAKeyCollection : public virtual IACollection < Element > {
public:

  virtual Key const&     key                         (Element const&) const = 0;

  virtual IBoolean       containsElementWithKey      (Key const&) const = 0;

  virtual IBoolean       containsAllKeysFrom         (IACollection <Element>
                                               const&) const;

  virtual IBoolean       locateElementWithKey        (Key const&, ICursor&)
                                               const = 0;

  virtual IBoolean       replaceElementWithKey       (Element const&) = 0;

  virtual IBoolean       replaceElementWithKey       (Element const&,
                                               ICursor&) = 0;

  virtual IBoolean       locateOrAddElementWithKey   (Element const&) = 0;

  virtual IBoolean       locateOrAddElementWithKey   (Element const&,
                                               ICursor&) = 0;

  virtual IBoolean       addOrReplaceElementWithKey  (Element const&) = 0;

  virtual IBoolean       addOrReplaceElementWithKey  (Element const&,
                                               ICursor&) = 0;

  virtual IBoolean       removeElementWithKey        (Key const&) = 0;

  virtual Element const& elementWithKey              (Key const&) const = 0;

  virtual Element&       elementWithKey              (Key const&) = 0;

  virtual INumber        numberOfElementsWithKey     (Key const&) const = 0;

  virtual IBoolean       locateNextElementWithKey    (Key const&,
                                               ICursor&) const = 0;

  virtual INumber        removeAllElementsWithKey    (Key const&) = 0;

  virtual INumber        numberOfDifferentKeys       () const = 0;

  virtual IBoolean       setToNextWithDifferentKey   (ICursor&) const = 0;

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iakey.c>
#endif
#endif

#endif
