/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

template < class Element, class Key >
INumber IAKeySet < Element, Key >::
numberOfElementsWithKey (Key const& key) const
{ if (containsElementWithKey (key))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
IBoolean IAKeySet < Element, Key >::
locateNextElementWithKey (Key const&, ICursor& cursor) const
{ elementAt (cursor); // just for precondition checking
  cursor.invalidate ();
  return False;
}

template < class Element, class Key >
INumber IAKeySet < Element, Key >::
removeAllElementsWithKey (Key const& key)
{ if (removeElementWithKey (key))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
INumber IAKeySet < Element, Key >::
numberOfDifferentKeys () const
{ return numberOfElements ();
}

template < class Element, class Key >
IBoolean IAKeySet < Element, Key >::
setToNextWithDifferentKey (ICursor& cursor) const
{ return setToNext (cursor);
}

