/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IAORDER_H
#define _IAORDER_H

#include <iglobals.h>
#include <icursor.h>
#include <iacllct.h>

template < class Element >
class IAOrderedCollection : public virtual IACollection < Element > {
public:

  virtual void           removeFirst                 () = 0;

  virtual void           removeLast                  () = 0;

  virtual void           removeAtPosition            (IPosition) = 0;

  virtual Element const& firstElement                () const = 0;

  virtual Element const& lastElement                 () const = 0;

  virtual Element const& elementAtPosition           (IPosition) const = 0;

  virtual IBoolean       setToLast                   (ICursor&) const = 0;

  virtual IBoolean       setToPrevious               (ICursor&) const = 0;

  virtual void           setToPosition               (IPosition,
                                               ICursor&) const = 0;

  virtual IBoolean       isFirst                     (ICursor const&) const = 0;

  virtual IBoolean       isLast                      (ICursor const&) const = 0;

};

#endif
