/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

template < class Element, class Key >
INumber IARelation < Element, Key >::
numberOfOccurrences (Element const& element) const
{ if (contains (element))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
IBoolean IARelation < Element, Key >::
locateNext (Element const&, ICursor& cursor) const
{ elementAt (cursor); // just for precondition checking
  cursor.invalidate ();
  return False;
}

template < class Element, class Key >
INumber IARelation < Element, Key >::
removeAllOccurrences (Element const& element)
{ if (remove (element))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
IBoolean IARelation < Element, Key >::
operator == (IARelation < Element, Key > const& collection) const
{ if (numberOfElements () != collection.numberOfElements ())
    return False;

  return containsAllFrom (collection);

}

template < class Element, class Key >
IBoolean IARelation < Element, Key >::
operator != (IARelation < Element, Key > const& collection) const
{ return ! operator == (collection);
}

