/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IAREL_H
#define _IAREL_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqkey.h>

template < class Element, class Key >
class IARelation :
  public virtual IAEqualityKeyCollection < Element, Key > {
public:

  virtual IBoolean       operator ==                 (IARelation < Element, Key > const&) const;

  virtual IBoolean       operator !=                 (IARelation < Element, Key > const&) const;

  virtual void           unionWith                   (IARelation < Element, Key > const&) = 0;

  virtual void           intersectionWith            (IARelation < Element, Key > const&) = 0;

  virtual void           differenceWith              (IARelation < Element, Key > const&) = 0;

  virtual void           addUnion                    (IARelation < Element, Key > const&,
                                               IARelation < Element, Key > const&) = 0;

  virtual void           addIntersection             (IARelation < Element, Key > const&,
                                               IARelation < Element, Key > const&) = 0;

  virtual void           addDifference               (IARelation < Element, Key > const&,
                                               IARelation < Element, Key > const&) = 0;

protected:

   INumber        numberOfOccurrences         (Element const&) const;

   IBoolean       locateNext                  (Element const&, ICursor&)
                                               const;

   INumber        removeAllOccurrences        (Element const&);

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iarel.c>
#endif
#endif

#endif
