/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IASET_H
#define _IASET_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>

template < class Element >
class IASet : public virtual IAEqualityCollection < Element > {
public:

  virtual IBoolean       operator ==                 (IASet < Element > const&) const;

  virtual IBoolean       operator !=                 (IASet < Element > const&) const;

  virtual void           unionWith                   (IASet < Element > const&) = 0;

  virtual void           intersectionWith            (IASet < Element > const&) = 0;

  virtual void           differenceWith              (IASet < Element > const&) = 0;

  virtual void           addUnion                    (IASet < Element > const&,
                                               IASet < Element > const&) = 0;

  virtual void           addIntersection             (IASet < Element > const&,
                                               IASet < Element > const&) = 0;

  virtual void           addDifference               (IASet < Element > const&,
                                               IASet < Element > const&) = 0;

protected:

   INumber        numberOfOccurrences         (Element const&) const;

   IBoolean       locateNext                  (Element const&, ICursor&)
                                               const;

   INumber        removeAllOccurrences        (Element const&);

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iaset.c>
#endif
#endif

#endif
