/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IASRTBAG_H
#define _IASRTBAG_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqsrt.h>

template < class Element >
class IASortedBag :
  public virtual IAEqualitySortedCollection < Element > {
public:

  virtual INumber        numberOfOccurrences         (Element const&) const = 0;

  virtual IBoolean       locateNext                  (Element const&, ICursor&)
                                               const = 0;

  virtual INumber        removeAllOccurrences        (Element const&) = 0;

  virtual INumber        numberOfDifferentElements   () const = 0;

  virtual IBoolean       setToNextDifferentElement   (ICursor&) const = 0;

  virtual IBoolean       operator ==                 (IASortedBag < Element > const&) const;

  virtual IBoolean       operator !=                 (IASortedBag < Element > const&) const;

  virtual void           unionWith                   (IASortedBag < Element > const&) = 0;

  virtual void           intersectionWith            (IASortedBag < Element > const&) = 0;

  virtual void           differenceWith              (IASortedBag < Element > const&) = 0;

  virtual void           addUnion                    (IASortedBag < Element > const&,
                                               IASortedBag < Element > const&) = 0;

  virtual void           addIntersection             (IASortedBag < Element > const&,
                                               IASortedBag < Element > const&) = 0;

  virtual void           addDifference               (IASortedBag < Element > const&,
                                               IASortedBag < Element > const&) = 0;

  virtual long           compare                     (IASortedBag < Element > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

protected:

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iasrtbag.c>
#endif
#endif

#endif
