/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IASRTREL_H
#define _IASRTREL_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqksrt.h>

template < class Element, class Key >
class IASortedRelation :
  public virtual IAEqualityKeySortedCollection < Element, Key > {
public:

  virtual IBoolean       operator ==                 (IASortedRelation < Element, Key > const&) const;

  virtual IBoolean       operator !=                 (IASortedRelation < Element, Key > const&) const;

  virtual void           unionWith                   (IASortedRelation < Element, Key > const&) = 0;

  virtual void           intersectionWith            (IASortedRelation < Element, Key > const&) = 0;

  virtual void           differenceWith              (IASortedRelation < Element, Key > const&) = 0;

  virtual void           addUnion                    (IASortedRelation < Element, Key > const&,
                                               IASortedRelation < Element, Key > const&) = 0;

  virtual void           addIntersection             (IASortedRelation < Element, Key > const&,
                                               IASortedRelation < Element, Key > const&) = 0;

  virtual void           addDifference               (IASortedRelation < Element, Key > const&,
                                               IASortedRelation < Element, Key > const&) = 0;

  virtual long           compare                     (IASortedRelation < Element, Key > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

protected:

   INumber        numberOfOccurrences         (Element const&) const;

   IBoolean       locateNext                  (Element const&, ICursor&)
                                               const;

   INumber        removeAllOccurrences        (Element const&);

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iasrtrel.c>
#endif
#endif

#endif
