/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IASRTSET_H
#define _IASRTSET_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqsrt.h>

template < class Element >
class IASortedSet :
  public virtual IAEqualitySortedCollection < Element > {
public:

  virtual IBoolean       operator ==                 (IASortedSet < Element > const&) const;

  virtual IBoolean       operator !=                 (IASortedSet < Element > const&) const;

  virtual void           unionWith                   (IASortedSet < Element > const&) = 0;

  virtual void           intersectionWith            (IASortedSet < Element > const&) = 0;

  virtual void           differenceWith              (IASortedSet < Element > const&) = 0;

  virtual void           addUnion                    (IASortedSet < Element > const&,
                                               IASortedSet < Element > const&) = 0;

  virtual void           addIntersection             (IASortedSet < Element > const&,
                                               IASortedSet < Element > const&) = 0;

  virtual void           addDifference               (IASortedSet < Element > const&,
                                               IASortedSet < Element > const&) = 0;

  virtual long           compare                     (IASortedSet < Element > const&,
                                               long (*comparisonFunction)
                                                  (Element const&,
                                                  Element const&)) const;

protected:

   INumber        numberOfOccurrences         (Element const&) const;

   IBoolean       locateNext                  (Element const&, ICursor&)
                                               const;

   INumber        removeAllOccurrences        (Element const&);

};

#ifdef __IBMCPP__
#ifndef __TEMPINC__
#include <iasrtset.c>
#endif
#endif

#endif
