#ifndef _IBITFLAG_INL_
#define _IBITFLAG_INL_ 0
/*******************************************************************************
* FILE NAME: ibitflag.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in ibitflag.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IBITFLAG_
  #undef  _IBITFLAG_INL_
  #define _IBITFLAG_INL_ 1
  #include <ibitflag.hpp>
#endif

#if _IBITFLAG_INL_
  #define inline
#endif

/*--------------------------------- IBitFlag ---------------------------------*/
inline IBitFlag :: IBitFlag ( unsigned long value )
  : ulClValue( value )
  {}
inline unsigned long  IBitFlag :: asUnsignedLong ( ) const
  {
  return ulClValue;
  }
inline IBitFlag  &IBitFlag :: setValue ( unsigned long value )
  {
  ulClValue = value;
  return *this;
  }
inline IBase::Boolean  IBitFlag :: operator == ( const IBitFlag &rhs ) const
  {
  return this->asUnsignedLong() == rhs.asUnsignedLong();
  }
inline IBase::Boolean  IBitFlag :: operator != ( const IBitFlag &rhs ) const
  {
  return this->asUnsignedLong() != rhs.asUnsignedLong();
  }

#endif /* _IBITFLAG_INL_ */
