#ifndef _ICANVAS_INL_
#define _ICANVAS_INL_ 0
/*******************************************************************************
* FILE NAME: icanvas.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in icanvas.hpp.                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
* CHANGE ACTIVITY:                                                             *
*******************************************************************************/
#ifndef _ICANVAS_
  #undef  _ICANVAS_INL_
  #define _ICANVAS_INL_ 1
  #include <icanvas.hpp>
#endif

#if _ICANVAS_INL_
  #define inline
#endif

/*-------------------------------- ICanvas -----------------------------------*/
inline void  ICanvas::setDefaultStyle ( const ICanvas::Style& style )
  {
  currentDefaultStyle = style;
  }
inline IWindowHandle  ICanvas::origDefaultButtonHandle ( ) const
  {
  return hwndClDefaultButton;
  }
inline const ISize  &ICanvas::layoutSize ( ) const
  {
  return sizClLayout;
  }
inline ICanvas  &ICanvas::setLayoutSize ( const ISize& size )
  {
  sizClLayout = size;
  return *this;
  }
inline IBase::Boolean  ICanvas::areChildrenReversed ( ) const
  {
  return bClChildrenReversed;
  }
#endif /* _ICANVAS_INL_ */
