#ifndef _ICCONST_
#define _ICCONST_
/*******************************************************************************
* FILE NAME: icconst.h                                                         *
*                                                                              *
* DESCRIPTION:                                                                 *
*   IBM Class Library: User Interface resource identifier macro constants.     *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#define IC_ASSERTPARM                          1
#define IC_MEMBER_ACCESS_ERROR                 2
#define IC_UNEXPECTED_ERROR                    3
#define IC_HEAP_EXHAUSTED                      4

#define IC_RELEASEPSFAIL                      30  // Release PS failed.
#define IC_INVALIDCHARCODE                    31  // Character code is not valid for this keyboard event
#define IC_INVALIDSCANCODE                    32  // Scan code is not valid for this keyboard event
#define IC_INVALIDVIRTUALKEY                  33  // Virtual key is not valid for this keyboard event
#define IC_PRESPARAMNOTFOUND                  34  // Presentation parameter value not found.
#define IC_INVALIDCOLORINDEX                  35  // Invalid color index specified.
#define IC_INVALIDEVENT                       36  // Event (message) is invalid for this function.
#define IC_DBCSCHARASSERT                     37  // DBCS string cannot be represend as SBCS
#define IC_DBCSSCANCODEASSERT                 38  // Scan code not valid for DBCS input.
#define IC_INVALIDENUMVALUE                   39  // Uninitialized enumerator value found.
#define IC_NOMARKEDTEXT                       40  // No marked text to copy, cut, clear, or delete.
#define IC_CLIPBOARDEMPTY                     41  // No data in the copyboard for pasting.
#define IC_HANDLERNOTFOUND                    42  // removeHandler and handler not found.
#define IC_INVALIDSTYLE                       43  // Incompatible styles specified.
#define IC_INVALIDSIZE                        44
#define IC_FRAME_EXTENSION_NOT_FOUND          45
#define IC_INVALID_THREAD_ID                  46
#define IC_THREAD_STARTED                     47
#define IC_SUSPEND_PM_THREAD                  48
#define IC_SEMAPHORES_EXHAUSTED               49
#define IC_VIEWPORT_INVALID_SCROLL            50
#define IC_ISTRING_OVERFLOW                   51
#define IC_ISTRING_INDEX_ERROR                52
#define IC_CNROBJ_INVALID_OBJECTCOPY          53
#define IC_CNROBJ_INVALID_CREATE              54
#define IC_MULTICELLCANVAS_CELL_OVERLAP       55
#define IC_DISPATCHTO_INVALID_HANDLER         56  // Attempt to dispatch to a "dead" handler
#define IC_INVALIDSIZE_LIMIT                  57
#define IC_NULL_IREFERENCE                    58

#define IC_HELPERRORMSGBOX_TITLE              80
#define IC_HMERR_LOAD_DLL                     81
#define IC_HMERR_NO_FRAME_WND_IN_CHAIN        82
#define IC_HMERR_INVALID_ASSOC_APP_WND        83
#define IC_HMERR_INVALID_ASSOC_HELP_INST      84
#define IC_HMERR_INVALID_QUERY_APP_WND        85
#define IC_HMERR_HELPTABLE_UNDEFINE           86
#define IC_HMERR_HELP_INSTANCE_UNDEFINE       87
#define IC_HMERR_HELPITEM_NOT_FOUND           88
#define IC_HMERR_INDEX_NOT_FOUND              89
#define IC_HMERR_CONTENT_NOT_FOUND            90
#define IC_HMERR_OPEN_LIB_FILE                91
#define IC_HMERR_READ_LIB_FILE                92
#define IC_HMERR_CLOSE_LIB_FILE               93
#define IC_HMERR_INVALID_LIB_FILE             94
#define IC_HMERR_NO_MEMORY                    95
#define IC_HMERR_FREE_MEMORY                  96
#define IC_HMERR_PANEL_NOT_FOUND              97
#define IC_HMERR_DATABASE_NOT_OPEN            98
#define IC_HMERR_UNKNOWN                      99
#define IC_THREAD_NOT_PROCESSING_MSGS        100
#define IC_FRAME_EXTENSION_IN_USE            101

#define IC_DDE_SERVER_IN_CONVERSATION        121
#define IC_DDE_CLIENT_NOT_IN_CONVERSATION    122
#define IC_DDE_SERVER_NOT_IN_CONVERSATION    123
#define IC_DDE_WINDDEINITIATE                124
#define IC_DDE_WINDDEPOSTMESSAGE_USER        125
#define IC_DDE_HOTLINK_ACTIVE                128
#define IC_DDE_HOTLINK_PENDING               129
#define IC_DDE_NO_HOTLINK                    130
#define IC_DDE_NO_HOTLINKS                   131
#define IC_DDE_NO_HOTLINKS_ITEM              132
#define IC_DDE_END_HOTLINK_PENDING           133
#define IC_DDE_END_HOTLINKS_ITEM_PENDING     134
#define IC_DDE_END_HOTLINKS_PENDING          135
#define IC_DDE_SYNCHRONIZATION               136
#define IC_INVALID_RANGE_OPERATION           138  /* ISpinButton */
#define IC_INVALID_TEXT_OPERATION            139  /* ISpinButton */
#define IC_SET_SPIN_ARRAY_FAIL               140  /* ISpinButton */
#define IC_SETMENUITEM_FAIL                  141  /* IMenu */
#define IC_INVALID_MENUITEM                  142  /* IMenu */
#define IC_NO_SYSTEMMENU                     143  /* ISystemMenu */
#define IC_NO_FRAME_MENUBAR                  144  /* IMenuBar */
#define IC_NO_BITMAP_HANDLE                  145  /* IMenu */
#define IC_NO_MENU_SELECTED                  147  /* IMenu */
#define IC_ADD_SUBMENU_FAIL                  148  /* IMenu */
#define IC_NO_TITLEBAR                       149  /* ITitle */
#define IC_SLDR_SET_CTLDATA                  150
#define IC_SLDR_GET_CTLDATA                  151
#define IC_NO_SUBMENU                        152
#define IC_NO_HELP_COVERPAGE                 153
#define IC_INVALID_INDEX                     154  /* IListBox and IComboBox */
#define IC_UNKNOWN_RENDERING_FORMAT          155
#define IC_UNKNOWN_RENDERING_MECHANISM       156
#define IC_RFPROCESS_FOR_SAME_PROCESS        157
#define IC_RENDER_AT_SOURCE_FAILED           158
#define IC_DRAGTRANSFER_INVALID              159
#define IC_NO_SOURCE_OBJECT_SUPPLIED         160
#define IC_INDEX_OUT_OF_RANGE                161
#define IC_TARGET_ITEM_PROVIDER_FAILED       162
#define IC_DRAGITEM_INVALID                  163

#define IC_FADEICON                          200  /* Fade icon for drag */

#define IC_DEFAULT_FRAME_ID                 1000
#define IC_FRAME_MENU_ID                    0x8005  /* FID_MENU */

#endif
