#ifndef _ICNRCLST_
#define _ICNRCLST_
/*******************************************************************************
* FILE NAME: icnrclst.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declaration(s) of the class(es):                    *
*     ICnrControlList                                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IBASE_
  #include <ibase.hpp>
#endif

#include <iset.h>

/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

// forward declarations here
class IContainerControl;

class ICnrControlList : public ISet<IContainerControl*>
{
/*******************************************************************************
* The ICnrControlList class defines a collection of IContainerControl          *
* instances.  It should be used by a subclass of IContainerControl in the      *
* implemention of the IContainerControl class.                                 *
*******************************************************************************/
public:
/*------------------------------- Constructor ----------------------------------
| You can construct instances of this class in the following ways:             |
|   - By using the default constructor.                                        |
|   - From an instance of ICnrControlList that already exists.                 |
------------------------------------------------------------------------------*/
  ICnrControlList  ();
  ICnrControlList  (const ICnrControlList&);
 ~ICnrControlList  ();
};

/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif // _ICNRCLST_
