#ifndef _ICNRCOL_INL_
#define _ICNRCOL_INL_ 0
/*******************************************************************************
* FILE NAME: icnrcol.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in icnrcol.hpp.                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ICNRCOL_
  #undef  _ICNRCOL_INL_
  #define _ICNRCOL_INL_ 1
  #include <icnrcol.hpp>
#endif


#if _ICNRCOL_INL_
  #define inline
#endif


inline _FIELDINFO* IContainerColumn :: columnInfo() const
  {return pfieldinfoCl; }

inline IContainerColumn& IContainerColumn :: setColumnInfo(_FIELDINFO* pfieldinfo) 
  {pfieldinfoCl = pfieldinfo;  return *this;}

inline IContainerColumn& IContainerColumn :: setContainer(IContainerControl* pcnrctl)
   {pcnrctlCl = pcnrctl; return *this; }

inline IContainerControl* IContainerColumn :: container() const
  { return pcnrctlCl; }

inline IContainerColumn& IContainerColumn::setHelpId (unsigned long helpId)
{ ulHelpId = helpId; return *this; }

inline unsigned long IContainerColumn::helpId ( ) const
{ return ulHelpId; }

#endif // _ICNRCOL_INL_

