#ifndef _ICNREHDR_INL_
#define _ICNREHDR_INL_ 0
/*******************************************************************************
* FILE NAME: icnrehdr.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in icnrehdr.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ICNREHDR_
  #undef  _ICNREHDR_INL_
  #define _ICNREHDR_INL_ 1
  #include <icnrehdr.hpp>
#endif


#if _ICNREHDR_INL_
  #define inline
#endif


inline IBase::Boolean ICnrEditHandler :: isDataIString()
{
   return (_stringType == isIString);
}


inline void ICnrEditHandler::setMLEHandler(IHandler* pMLEHandler)
{
  _phdrMLE = pMLEHandler;
}


/* Implementation: Return the handler for the containers MLE. */
inline IHandler* ICnrEditHandler::mleHandler( ) const
{
  return _phdrMLE;
}


#endif // _ICNREHDR_INL_

