#ifndef _ICNROLST_
#define _ICNROLST_
/*******************************************************************************
* FILE NAME: icnrolst.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declaration(s) of the class(es):                    *
*     ICnrObjectSet                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IBASE_
  #include <ibase.hpp>
#endif

#include <iseq.h>

/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

// forward declarations here
class IContainerObject;

/*----------------------------------------------------------*/
/* Object Collection Definition.                            */
/*----------------------------------------------------------*/
class ICnrObjectSet : public ISequence<IContainerObject*> {
/*******************************************************************************
* The ICnrObjectSet class defines a set of IContainerObjects.  Several         *
* functions exist in IContainerControl that return sets of IContainerObjects   *
* that meet a certain criteria.  For example, the descendentsOf function       *
* returns the set of all descendents of an object in the tree view.            *
*******************************************************************************/
public:
/*------------------------ Constructors ----------------------------------------
| You can construct instances of this class in the following ways:             |
|   - By using the default constructor.                                        |
|   - From an instance of ICnrObjectSet that already exists.                   |
------------------------------------------------------------------------------*/
  ICnrObjectSet( );
  ICnrObjectSet(const ICnrObjectSet&);
 ~ICnrObjectSet( );
};

/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif // _ICNROLST_
