#ifndef _ICOLOR_INL_
#define _ICOLOR_INL_ 0
/*******************************************************************************
* FILE NAME: icolor.inl                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in icolor.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ICOLOR_
  #undef  _ICOLOR_INL_
  #define _ICOLOR_INL_ 1
  #include <icolor.hpp>
#endif


#if _ICOLOR_INL_
  #define inline
#endif

inline unsigned char IColor::redMix() const
/**************************************************************/
/* Return the red value.                                      */
/**************************************************************/
{ return ucClRed; }

inline unsigned char IColor::blueMix() const
/**************************************************************/
/* Return the blue value.                                     */
/**************************************************************/
{ return ucClBlue; }

inline unsigned char IColor::greenMix() const
/**************************************************************/
/* Return the green value.                                    */
/**************************************************************/
{ return ucClGreen; }

inline IColor& IColor::setRed(unsigned char redMix)
{
   ucClRed = redMix;
   return *this;
}

inline IColor& IColor::setGreen(unsigned char greenMix)
{
   ucClGreen = greenMix;
   return *this;
}

inline IColor& IColor::setBlue(unsigned char blueMix)
{
   ucClBlue  = blueMix;
   return *this;
}
#endif // _ICOLOR_INL_
