#ifndef _IDBCSBUF_INL_
#define _IDBCSBUF_INL_ 0
/*******************************************************************************
* FILE NAME: idbcsbuf.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in idbcsbuf.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IDBCSBUF_
  #undef  _IDBCSBUF_INL_
  #define _IDBCSBUF_INL_ 1
  #include <idbcsbuf.hpp>
#endif

#if _IDBCSBUF_INL_
  #define inline
#endif

inline IBase::Boolean IDBCSBuffer :: isDBCS1 ( unsigned pos ) const
  {
  return dbcsTable[ (unsigned) ( this->contents()[ pos-1 ] ) ];
  }

inline IBase::Boolean IDBCSBuffer :: isPrevDBCS ( unsigned pos ) const
  {
  return ( pos < 3 ) ?
    false
  :
    this->charType( pos-1 ) == IStringEnum::dbcs2;
  }
#endif // _IDBCSBUF_INL_
