#ifndef _IDDECCNV_INL_
#define _IDDECCNV_INL_ 0
/*******************************************************************************
* FILE NAME: iddeccnv.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in iddeccnv.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IDDECCNV_
  #undef  _IDDECCNV_INL_
  #define _IDDECCNV_INL_ 1
  #include <iddeccnv.hpp>
#endif

#if _IDDECCNV_INL_
  #define inline
#endif

inline IString IDDEClientConversation :: application ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::application                                          |
------------------------------------------------------------------------------*/
{
   return strClApplication;
}

inline IString IDDEClientConversation :: topic ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::topic                                                |
------------------------------------------------------------------------------*/
{
   return strClTopic;
}

inline IBase::Boolean IDDEClientConversation :: isCaseSensitive ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::caseSensitive                                        |
------------------------------------------------------------------------------*/
{
   return fClCaseSensitive;
}

inline IWindowHandle IDDEClientConversation :: serverHandle ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::serverHandle                                         |
------------------------------------------------------------------------------*/
{    
   return wndhClServer;
}    

inline IBase::Boolean IDDEClientConversation :: inConversation ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::inConversation                                       |
------------------------------------------------------------------------------*/
{
   if (serverHandle())
      return true;
   else
      return false;
}
     
inline IWindowHandle IDDEClientConversation :: clientHandle ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::clientHandle                                         |
------------------------------------------------------------------------------*/
{    
   return wndhClClient;
}    
     
inline IDDEClosedConversationSet& IDDEClientConversation :: closedConversations ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::closedConversations                                  |
------------------------------------------------------------------------------*/
{    
   return *pClsdConvSetCl;
}    
     
inline IDDETransactionQueue& IDDEClientConversation :: transactions ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::transactions                                         |
------------------------------------------------------------------------------*/
{    
   return *pTransQCl;
}

inline IDDEFormatSet& IDDEClientConversation :: formats ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::formats                                              |
------------------------------------------------------------------------------*/
{
   return *pFormatSetCl;
}

inline unsigned long IDDEClientConversation :: queueHandle ( ) const
/*------------------------------------------------------------------------------
| IDDEClientConversation::queueHandle                                          |
------------------------------------------------------------------------------*/
{
   return ulClQHandle;
}

#endif // _IDDECCNV_INL_

