#ifndef _IDDEEVT_INL_
#define _IDDEEVT_INL_ 0
/*******************************************************************************
* FILE NAME: iddeevt.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in iddeevt.hpp.                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IDDEEVT_
  #undef  _IDDEEVT_INL_
  #define _IDDEEVT_INL_ 1
  #include <iddeevt.hpp>
#endif

#if _IDDEEVT_INL_
  #define inline
#endif

inline IString IDDEEvent :: item ( ) const
/*------------------------------------------------------------------------------
| IDDEEvent::item                                                              |
------------------------------------------------------------------------------*/
{
   return strClItem;
}

inline IString IDDEEvent :: format ( ) const
/*------------------------------------------------------------------------------
| IDDEEvent::format                                                            |
------------------------------------------------------------------------------*/
{
   return strClFormat;
}

inline IDDEEvent& IDDEEvent :: setStatus ( unsigned short status )
/*------------------------------------------------------------------------------
| IDDEEvent::setStatus                                                         |
------------------------------------------------------------------------------*/
{
   usClStatus = status;
   return *this;
}

inline unsigned short IDDEEvent :: status ( ) const
/*------------------------------------------------------------------------------
| IDDEEvent::status                                                            |
------------------------------------------------------------------------------*/
{
   return usClStatus;
}

inline IDDEEvent& IDDEEvent :: setBuffer ( IString strBuf )
/*------------------------------------------------------------------------------
| IDDEEvent::setBuffer                                                         |
------------------------------------------------------------------------------*/
{
   strClData = strBuf;
   return *this;
}

inline IDDEEvent& IDDEEvent :: setFormat ( IString strFormat )
/*------------------------------------------------------------------------------
| IDDEEvent::setFormat                                                         |
------------------------------------------------------------------------------*/
{
   strClFormat = strFormat;
   return *this;
}

inline IString IDDEEvent :: buffer ( ) const
/*------------------------------------------------------------------------------
| IDDEEvent::buffer                                                            |
------------------------------------------------------------------------------*/
{
   return strClData;
}

/***************************************************************/
/*  IDDEAcknowledgeEvent Public Member Functions               */
/***************************************************************/

inline unsigned short IDDEAcknowledgeEvent :: transactionType ( ) const
/*------------------------------------------------------------------------------
| IDDEAcknowledgeEvent::transactionType                                        |
------------------------------------------------------------------------------*/
{
   return (unsigned short)eventId();
}

/***************************************************************/
/*  IDDEServerAcknowledgeEvent Public Member Functions         */
/***************************************************************/

inline IString IDDEServerAcknowledgeEvent :: data ( ) const
/*------------------------------------------------------------------------------
| IDDEServerAcknowledgeEvent::data                                             |
------------------------------------------------------------------------------*/
{
   return buffer();
}

/***************************************************************/
/*  IDDEAcknowledgePokeEvent Public Member Functions           */
/***************************************************************/

inline IString IDDEAcknowledgePokeEvent :: pokedData ( ) const
/*------------------------------------------------------------------------------
| IDDEAcknowledgePokeEvent::pokedData                                          |
------------------------------------------------------------------------------*/
{
   return buffer();
}

/***************************************************************/
/*  IDDEAcknowledgeExecuteEvent Public Member Functions        */
/***************************************************************/

inline IString IDDEAcknowledgeExecuteEvent :: commands ( ) const
/*------------------------------------------------------------------------------
| IDDEAcknowledgeExecuteEvent::commands                                        |
------------------------------------------------------------------------------*/
{
   return buffer();
}

/***************************************************************/
/*  IDDEDataEvent Public Member Functions                      */
/***************************************************************/

inline IString IDDEDataEvent :: data ( ) const
/*------------------------------------------------------------------------------
| IDDEDataEvent::data                                                          |
------------------------------------------------------------------------------*/
{
   return buffer();
}

/***************************************************************/
/*  IDDEPokeEvent Public Member Functions                      */
/***************************************************************/

inline IString IDDEPokeEvent :: pokedData ( ) const
/*------------------------------------------------------------------------------
| IDDEPokeEvent::pokedData                                                     |
------------------------------------------------------------------------------*/
{
   return buffer();
}

/***************************************************************/
/*  IDDEExecuteEvent Public Member Functions                   */
/***************************************************************/

inline IString IDDEExecuteEvent :: commands ( ) const
/*------------------------------------------------------------------------------
| IDDEExecuteEvent::commands                                                   |
------------------------------------------------------------------------------*/
{
   return buffer();
}

/***************************************************************/
/*  IDDEEndEvent Public Member Functions                       */
/***************************************************************/

inline IDDEEndEvent::Source IDDEEndEvent :: sourceOfEnd ( ) const
/*------------------------------------------------------------------------------
| IDDEEndEvent::sourceOfEnd                                                    |
------------------------------------------------------------------------------*/
{
   return sourceCl;
}

/***************************************************************/
/*  IDDEClientEndEvent Public Member Functions                 */
/***************************************************************/

inline IString IDDEClientEndEvent :: application ( ) const
/*------------------------------------------------------------------------------
| IDDEClientEndEvent::application                                              |
------------------------------------------------------------------------------*/
{
   return strClApp;
}

inline IString IDDEClientEndEvent :: topic ( ) const
/*------------------------------------------------------------------------------
| IDDEClientEndEvent::topic                                                    |
------------------------------------------------------------------------------*/
{
   return strClTopic;
}

/***************************************************************/
/*  IDDEBeginEvent Public Member Functions                     */
/***************************************************************/

inline IString IDDEBeginEvent :: application ( ) const
/*------------------------------------------------------------------------------
| IDDEBeginEvent::application                                                  |
------------------------------------------------------------------------------*/
{ 
   return strClApp;
}

inline IString IDDEBeginEvent :: topic ( ) const
/*------------------------------------------------------------------------------
| IDDEBeginEvent::topic                                                        |
------------------------------------------------------------------------------*/
{ 
   return strClTopic; 
}

inline IBase::Boolean IDDEBeginEvent :: isCaseSensitive ( ) const
/*------------------------------------------------------------------------------
| IDDEBeginEvent::isCaseSensitive                                              |
------------------------------------------------------------------------------*/
{  
   return bClCaseSens;
}

inline IDDEBeginEvent& IDDEBeginEvent :: setCaseSensitive ( Boolean caseSensitive )
/*------------------------------------------------------------------------------
| IDDEBeginEvent::setCaseSensitive                                             |
------------------------------------------------------------------------------*/
{  
   if (!caseSensitive)
      bClCaseSens = false;
   else
      bClCaseSens = true;
   return *this;
}

#endif // _IDDEEVT_INL_
