#ifndef _IDDETSRV_INL_
#define _IDDETSRV_INL_ 0
/*******************************************************************************
* FILE NAME: iddetsrv.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in iddetsrv.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IDDETSRV_
  #undef  _IDDETSRV_INL_
  #define _IDDETSRV_INL_ 1
  #include <iddetsrv.hpp>
#endif

#if _IDDETSRV_INL_
  #define inline
#endif

inline IWindowHandle IDDETopicServer :: serverHandle ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::serverHandle                                                |
------------------------------------------------------------------------------*/
{
   return wndhClServer;
}

inline IString IDDETopicServer :: application ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::application                                                 |
------------------------------------------------------------------------------*/
{
   return strClApplication;
}

inline IString IDDETopicServer :: topic ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::topic                                                       |
------------------------------------------------------------------------------*/
{
   return strClTopic;
}

inline IDDEServerConversationSet& IDDETopicServer :: closedConversations ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::closedConversations                                         |
------------------------------------------------------------------------------*/
{
   return *pClsdConvSetCl;
}

inline IDDEServerConversationSet& IDDETopicServer :: conversations ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::conversations                                               |
------------------------------------------------------------------------------*/
{
   return *pConvSetCl;
}

inline IDDEServerHotLinkItemSet& IDDETopicServer :: hotLinkItems ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::hotLinkItems                                                |
------------------------------------------------------------------------------*/
{
   return *pHLItemSetCl;
}

inline IDDEFormatSet& IDDETopicServer :: formats ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::formats                                                     |
------------------------------------------------------------------------------*/
{
   return *pFormatSetCl;
}

inline unsigned long IDDETopicServer :: queueHandle ( ) const
/*------------------------------------------------------------------------------
| IDDETopicServer::queueHandle                                                 |
------------------------------------------------------------------------------*/
{
   return ulClQHandle;
}

#endif // _IDDETSRV_INL_
