#ifndef _IDMIMAGE_INL_
  #define _IDMIMAGE_INL_ 0
/*******************************************************************************
* FILE NAME: idmimage.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in idmimage.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IDMIMAGE_
  #undef  _IDMIMAGE_INL_
  #define _IDMIMAGE_INL_ 1
  #include <idmimage.hpp>
#endif

#if _IDMIMAGE_INL_
  #define inline
#endif

/*------------------------------------------------------------------------------
| Inlines for IDMImage                                                         |
------------------------------------------------------------------------------*/
inline IPointerHandle IDMImage::pointer ()
{
  return (this->pointerImage);
}

inline IBitmapHandle IDMImage::bitmap ()
{
  return (this->bitmapImage);
}

inline ISize IDMImage::pointerOffset ()
{
  return (this->ptrOffset);
}

inline ISize IDMImage::stretchSize ()
{
  return (this->imageStretchSize);
}

inline IDMImage::Style IDMImage::style ()
{
  return (this->imgStyle);
}

inline unsigned long IDMImage::numberOfPoints ()
{
  return (this->points);
}

inline unsigned long* IDMImage::pointArray()
{
  return (this->pointArr);
}

inline IDMImage& IDMImage::setPointerOffset (ISize& pointerOffset)
{
  this->ptrOffset = pointerOffset;
  return (*this);
}

inline IDMImage& IDMImage::setStyle (IDMImage::Style style)
{
  this->imgStyle = style;
  return (*this);
}

inline IDMImage& IDMImage::setNumberOfPoints (unsigned long pts)
{
  this->points = pts;
  return (*this);
}

#endif //IDMIMAGE
