#ifndef _IDMITEM_INL_
  #define _IDMITEM_INL_ 0
/*******************************************************************************
* FILE NAME: idmitem.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in idmitem.hpp.                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IDMITEM_
  #undef  _IDMITEM_INL_
  #define _IDMITEM_INL_ 1
  #include <idmitem.hpp>
#endif


#if _IDMITEM_INL_
  #define inline
#endif


/*------------------------------------------------------------------------------
| Inlines for IDMItem                                                          |
------------------------------------------------------------------------------*/
inline unsigned IDMItem :: renderer() const
{
  return(this->rendererPosition);
}

inline IString IDMItem :: selectedRMF() const
{
  return(this->strSelectedRMF);
}

inline IDM::DropIndicator IDMItem :: dropStatus() const
{
  return(this->drpStatus);
}

inline Boolean IDMItem::hasImage() const
{
  return (!(!this->pIDMImage));
}

#endif // _IDMITEM_INL_
