#ifndef _IEVENT_INL_
#define _IEVENT_INL_ 0
/*******************************************************************************
* FILE NAME: ievent.inl                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in ievent.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IEVENT_
  #undef  _IEVENT_INL_
  #define _IEVENT_INL_ 1
  #include <ievent.hpp>
#endif

#if _IEVENT_INL_
  #define inline
#endif


inline  IWindowHandle IEvent::handle() const
/**************************************************************/
/* Return the handle of the window or queue receiving the     */
/* event.                                                     */
/**************************************************************/
{ return (IWindowHandle)hCl; }

inline unsigned long IEvent::eventId() const
/**************************************************************/
/* Return the event ID.                                       */
/**************************************************************/
{ return ulClEvtId; }

inline  IEventParameter1 IEvent::parameter1() const
/**************************************************************/
/* Return the first event parameter.                          */
/**************************************************************/
{ return epCl1; }

inline IEventParameter2 IEvent::parameter2() const
/**************************************************************/
/* Return the second event parameter.                         */
/**************************************************************/
{ return epCl2; }

inline IEvent& IEvent::setResult(const IEventResult& er)
/**************************************************************/
/* Set the event result.                                      */
/**************************************************************/
{ erCl = er;  return *this;}

inline IEventResult IEvent::result() const
/**************************************************************/
/* Return the event result.                                   */
/**************************************************************/
{ return erCl; }

#endif // _IEVENT_INL_
