#ifndef _IFILEDLG_INL_
#define _IFILEDLG_INL_ 0
/*******************************************************************************
* FILE NAME: ifiledlg.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in ifiledlg.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IFILEDLG_
  #undef  _IFILEDLG_INL_
  #define _IFILEDLG_INL_ 1
  #include <ifiledlg.hpp>
#endif

#if _IFILEDLG_INL_
  #define inline
#endif

/*-------------------------- IFileDialog::Settings ---------------------------*/
inline IFileDialog::Settings&  IFileDialog::Settings :: setOpenDialog ( )
{
  _isOpenDialog = true;
  return *this;
}

inline IFileDialog::Settings&  IFileDialog::Settings :: setSaveAsDialog ( )
{
  _isOpenDialog = false;
  return *this;
}

inline IBase::Boolean  IFileDialog::Settings :: isOpenDialog ( ) const
{
  return _isOpenDialog;
}

inline IFileDialog::Settings&
  IFileDialog::Settings :: setPosition ( const IPoint& position )
{
  _isPositionSet = true;
  _position = position;
  return *this;
}

inline IBase::Boolean  IFileDialog::Settings :: isPositionSet ( ) const
{
  return _isPositionSet;
}

inline IPoint  IFileDialog::Settings :: position ( ) const
{
  return _position;
}


inline IString  IFileDialog::Settings :: title ( ) const
{
  return _title;
}

inline IString  IFileDialog::Settings :: OKButtonText ( ) const
{
  return _OKButtonText;
}

inline IString  IFileDialog::Settings :: fileName ( ) const
{
  return _fileName;
}

inline IString  IFileDialog::Settings :: initialDrive ( ) const
{
  return _initialDrive;
}

inline IString  IFileDialog::Settings :: initialFileType ( ) const
{
  return _initialFileType;
}

inline StringSeq*  IFileDialog::Settings :: fileTypes ( ) const
{
  return _fileTypes;
}

inline StringSeq*  IFileDialog::Settings :: drives( ) const
{
  return _drives;
}


inline IBase::Boolean  IFileDialog::Settings :: isDialogTemplateSet ( ) const
{
  return _isDialogTemplateSet;
}


inline void  IFileDialog :: setDefaultStyle ( IFileDialog::Style newDefault )
{
  currentDefaultStyle = newDefault;
}

#endif // _IFILEDLG_INL_
