#ifndef _IFONTDLG_INL_
#define _IFONTDLG_INL_ 0
/*******************************************************************************
* FILE NAME: ifontdlg.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in ifontdlg.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IFONTDLG_
  #undef  _IFONTDLG_INL_
  #define _IFONTDLG_INL_ 1
  #include <ifontdlg.hpp>
#endif


#if _IFONTDLG_INL_
  #define inline
#endif


inline IFontDialog :: IFontDialog(IWindow*    parent,
                           IWindow*    owner,
                           Style       style )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   Settings tempSettings;
   initialize(parent, owner, style, (IHandler*)0, tempSettings );

}

inline IFontDialog :: IFontDialog(IWindow*    parent,
                           IWindow*    owner,
                           const Settings& settings,
                           Style       style )
             : IFrameWindow(IFrameWindow::deferCreation)
{

   initialize(parent, owner, style, (IHandler*)0, settings );
}

inline IFontDialog :: IFontDialog(IWindow*    parent,
                           IWindow*    owner,
                           Style       style,
                           const Settings& settings )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, (IHandler*)0, settings );

}

inline IFontDialog :: IFontDialog(IWindow*    parent,
                           IWindow*    owner,
                           IHandler*   handler,
                           Style       style,
                           const Settings& settings )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, handler, settings );

}



inline void  IFontDialog :: setDefaultStyle(IFontDialog::Style newDefault)
/***************************************************************/
/* Replace the default style for new  objects.                 */
/***************************************************************/
{
  currentDefaultStyle = newDefault;
}

#endif // _IFONTDLG_INL_

