/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IHEAPSEQ_H
#define _IHEAPSEQ_H

#include <iglobals.h>
#include <icursor.h>

template < class Element, class ElementOps, class Base >
class IWHeapOnSeq {
  Base ivBase;
  class Cursor;
  friend class Cursor;
public:

  class Cursor : public Base::Cursor {
  protected:
    IBoolean isFor (IWHeapOnSeq < Element, ElementOps, Base > const& c) const
    { return Base::Cursor::isFor (c.ivBase); }

  public:
    Cursor (IWHeapOnSeq < Element, ElementOps, Base > const& c)
    : Base::Cursor (c.ivBase) {}
  };

                  IWHeapOnSeq             (INumber
                                               numberOfElements = 100);

                  IWHeapOnSeq             (IWHeapOnSeq < Element, ElementOps, Base > const&);

   IWHeapOnSeq < Element, ElementOps, Base >&
                  operator =                  (IWHeapOnSeq < Element, ElementOps, Base > const&);

                 ~IWHeapOnSeq             ();

   IBoolean       add                         (Element const&);

   IBoolean       add                         (Element const&,
                                               ICursor&);

   void           addAllFrom                  (IWHeapOnSeq < Element, ElementOps, Base > const&);

   Element const& elementAt                   (ICursor const&) const;

   Element&       elementAt                   (ICursor const&);

   Element const& anyElement                  () const;

   void           removeAt                    (ICursor const&);

   INumber        removeAll                   (IBoolean (*property)
                                               (Element const&, void*),
                                               void* additionalArgument = 0);

   void           replaceAt                   (ICursor const&,
                                               Element const&);

   void           removeAll                   ();

   IBoolean       isBounded                   () const;

   INumber        maxNumberOfElements         () const;

   INumber        numberOfElements            () const;

   IBoolean       isEmpty                     () const;

   IBoolean       isFull                      () const;

   ICursor*       newCursor                   () const;

   IBoolean       setToFirst                  (ICursor&) const;

   IBoolean       setToNext                   (ICursor&) const;

   IBoolean       allElementsDo               (IBoolean (*function)
                                                  (Element&, void*),
                                               void* additionalArgument = 0);

   IBoolean       allElementsDo               (IIterator <Element>&);

   IBoolean       allElementsDo               (IBoolean (*function)
                                               (Element const&, void*),
                                               void* additionalArgument = 0)
                                               const;

   IBoolean       allElementsDo               (IConstantIterator
                                                  <Element>&) const;

   IBoolean       isConsistent                () const;

};

#define IDefineGHeapOnGSequence(GSeq, GHeap) \
template < class Element, class ElementOps > \
class GHeap : \
  public IWHeapOnSeq < Element, ElementOps, \
                       GSeq < Element, ElementOps > > { \
public: \
  GHeap (INumber n = 100) : \
    IWHeapOnSeq < Element, ElementOps, \
                  GSeq < Element, ElementOps > > (n) {} \
};

#include <iheapseq.if>

#endif
