#ifndef _IKEYEVT_INL_
#define _IKEYEVT_INL_ 0
/*******************************************************************************
* FILE NAME: ikeyevt.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in ikeyevt.hpp.                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IKEYEVT_
  #undef  _IKEYEVT_INL_
  #define _IKEYEVT_INL_ 1
  #include <ikeyevt.hpp>
#endif

#if _IKEYEVT_INL_
  #define inline
#endif

/*------------------------------ IKeyboardEvent ------------------------------*/
inline IBase::Boolean  IKeyboardEvent :: isCharacter ( ) const
  {
  return ((parameter1().number1() & ulCharacterFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isScanCode ( ) const
  {
  return ((parameter1().number1() & ulScanCodeFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isVirtual ( ) const
  {
  return ((parameter1().number1() & ulVirtualFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isUpTransition ( ) const
  {
  return ((parameter1().number1() & ulUpTransitionFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isRepeat ( ) const
  {
  return ((parameter1().number1() & ulRepeatFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isUncombined ( ) const
  {
  return ((parameter1().number1() & ulUncombinedFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isShiftDown ( ) const
  {
  return ((parameter1().number1() & ulShiftFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isCtrlDown ( ) const
  {
  return ((parameter1().number1() & ulCtrlFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isAltDown ( ) const
  {
  return ((parameter1().number1() & ulAltFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isForComposite ( ) const
  {
  return ((parameter1().number1() & ulForCompositeFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isComposite ( ) const
  {
  return ((parameter1().number1() & ulCompositeFlag) ? true : false);
  }
inline IBase::Boolean  IKeyboardEvent :: isInvalidComposite ( ) const
  {
  return ((parameter1().number1() & ulInvalidCompositeFlag) ? true : false);
  }

#endif // _IKEYEVT_INL_
