#ifndef _IMNDIEVT_
#define _IMNDIEVT_
/*******************************************************************************
* FILE NAME: imndievt.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IMenuDrawItemEvent - The owner-draw menu event information class         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#if !defined( _IDIEVT_ )
  #include <idievt.hpp>
#endif

/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

// Forward declarations for other classes:
class IMenuDrawItemHandler;

class IMenuDrawItemEvent : public IDrawItemEvent {
typedef IDrawItemEvent Inherited;
/*******************************************************************************
* The IMenuDrawItemEvent class provides the draw item event information for    *
* the draw item menu items.                                                    *
*******************************************************************************/
public:
/*------------------------ Constructor -----------------------------------------
| The only way to construct instances of this class is from an instance of     |
| the IEvent class.                                                            |
------------------------------------------------------------------------------*/
  IMenuDrawItemEvent(IEvent& evt)
    : Inherited(evt) {}

/*-------------------------------- Testing -------------------------------------
| These functions provide a means of testing the display attributes of a       |
| menu item about to be drawn.  You would use these only if you intend to do   |
| your own drawing for the selected, checked, or disabled display attributes   |
| of a menu item.  These functions are only meant be be called from within an  |
| overridden version of IMenuDrawItemHandler::draw().                          |
|   isSelected - Returns true if the menu item is selected.                    |
|   isChecked  - Returns true if the menu item is checked.                     |
|   isDisabled - Returns true if the menu item is disabled.                    |
------------------------------------------------------------------------------*/
Boolean
  isSelected() const,
  isChecked() const,
  isDisabled() const;


private: /*------------------------ PRIVATE ----------------------------------*/
friend IMenuDrawItemHandler;

Boolean
  isDrawItem() const,
  isSetHighlight() const,
  isRemoveHighlight() const;

};

/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif /* _IMNDIEVT_ */
