#ifndef _IOBJWIN_
#define _IOBJWIN_
/*******************************************************************************
* FILE NAME: iobjwin.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IObjectWindow -  Invisible Window Class                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IWINDOW_
  #include <iwindow.hpp>
#endif

/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

/*----------------------------------------------------------------------------*/
/* Turn off warning for compiler generated copy/assignment                    */
/*----------------------------------------------------------------------------*/
#pragma info(nocpy)

class IObjectWindow : public IWindow {
typedef IWindow
  Inherited;
/*******************************************************************************
* The IObjectWindow class allows you to create object windows.  Object         *
* windows are invisible windows that process window events.  These windows     *
* have minimal system overhead because they are created with a parent of       *
* HWND_OBJECT.  Essentially, these windows only see messages that are          *
* explicitly sent to them.                                                     *
*                                                                              *
* One possible use of this class would be to process a set of user-defined     *
* messages.                                                                    *
*******************************************************************************/
public:
/*------------------------ Constructor -----------------------------------------
| The only way to construct instances of this class is to use the default      |
| constructor.  The default constructor is used to create an IObjectWindow     |
| that starts handling events immediately.                                     |
------------------------------------------------------------------------------*/
  IObjectWindow ( );
virtual
 ~IObjectWindow ( );

}; // IObjectWindow

/*----------------------------------------------------------------------------*/
/* Resume compiler default packing and warning messages.                      */
/*----------------------------------------------------------------------------*/
#pragma pack()
#pragma info(restore)

#endif
