/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM C/C++ Tools Version 2.01 - Collection Class Library                    *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

template < class Element, class Key, class Base >
void* IRKeySortedBag < Element, Key, Base >::
identity () const
{ return (void*)&ivBase;
}

template < class Element, class Key, class Base >
IRKeySortedBag < Element, Key, Base >::
~IRKeySortedBag ()
{
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
add (Element const& element)
{ return ivBase.add (element);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
add (Element const& element, ICursor &cursor)
{ return ivBase.add (element, cursor);
}

template < class Element, class Key, class Base >
Element const& IRKeySortedBag < Element, Key, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (cursor);
}

template < class Element, class Key, class Base >
Element& IRKeySortedBag < Element, Key, Base >::
elementAt (ICursor const& cursor)
{ return ivBase.elementAt (cursor);
}

template < class Element, class Key, class Base >
Element const& IRKeySortedBag < Element, Key, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class Key, class Base >
void IRKeySortedBag < Element, Key, Base >::
removeAt (ICursor const& cursor)
{ ivBase.removeAt (cursor);
}

template < class Element, class Key, class Base >
INumber IRKeySortedBag < Element, Key, Base >::
removeAll (IBoolean (*predicate) (Element const&, void*), void* env)
{ return ivBase.removeAll (predicate, env);
}

template < class Element, class Key, class Base >
void IRKeySortedBag < Element, Key, Base >::
replaceAt (ICursor const& cursor, Element const& element)
{ ivBase.replaceAt (cursor, element);
}

template < class Element, class Key, class Base >
void IRKeySortedBag < Element, Key, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class Key, class Base >
INumber IRKeySortedBag < Element, Key, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class Key, class Base >
INumber IRKeySortedBag < Element, Key, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class Key, class Base >
ICursor* IRKeySortedBag < Element, Key, Base >::
newCursor () const
{ return ivBase.newCursor ();
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element &, void*),
               void* environment)
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
allElementsDo (IIterator <Element>& iterator)
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

template < class Element, class Key, class Base >
Key const& IRKeySortedBag < Element, Key, Base >::
key (Element const& element) const
{ return ivBase.key (element);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
containsElementWithKey (Key const& key) const
{ return ivBase.containsElementWithKey (key);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
locateElementWithKey (Key const& key, ICursor &cursor) const
{ return ivBase.locateElementWithKey (key, cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
replaceElementWithKey (Element const& element)
{ return ivBase.replaceElementWithKey (element);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
replaceElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.replaceElementWithKey (element, cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
locateOrAddElementWithKey (Element const& element)
{ return ivBase.locateOrAddElementWithKey (element);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
locateOrAddElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.locateOrAddElementWithKey (element, cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
addOrReplaceElementWithKey (Element const& element)
{ return ivBase.addOrReplaceElementWithKey (element);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
addOrReplaceElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.addOrReplaceElementWithKey (element, cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
removeElementWithKey (Key const& key)
{ return ivBase.removeElementWithKey (key);
}

template < class Element, class Key, class Base >
Element const& IRKeySortedBag < Element, Key, Base >::
elementWithKey (Key const& key) const
{ return ivBase.elementWithKey (key);
}

template < class Element, class Key, class Base >
Element& IRKeySortedBag < Element, Key, Base >::
elementWithKey (Key const& key)
{ return ivBase.elementWithKey (key);
}

template < class Element, class Key, class Base >
INumber IRKeySortedBag < Element, Key, Base >::
numberOfElementsWithKey (Key const& key) const
{ return ivBase.numberOfElementsWithKey (key);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
locateNextElementWithKey (Key const& key, ICursor& cursor) const
{ return ivBase.locateNextElementWithKey (key, cursor);
}

template < class Element, class Key, class Base >
INumber IRKeySortedBag < Element, Key, Base >::
removeAllElementsWithKey (Key const& key)
{ return ivBase.removeAllElementsWithKey (key);
}

template < class Element, class Key, class Base >
INumber IRKeySortedBag < Element, Key, Base >::
numberOfDifferentKeys () const
{ return ivBase.numberOfDifferentKeys ();
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
setToNextWithDifferentKey (ICursor& cursor) const
{ return ivBase.setToNextWithDifferentKey (cursor);
}

template < class Element, class Key, class Base >
void IRKeySortedBag < Element, Key, Base >::
removeFirst ()
{ ivBase.removeFirst ();
}

template < class Element, class Key, class Base >
void IRKeySortedBag < Element, Key, Base >::
removeLast ()
{ ivBase.removeLast ();
}

template < class Element, class Key, class Base >
void IRKeySortedBag < Element, Key, Base >::
removeAtPosition (IPosition position)
{ ivBase.removeAtPosition (position);
}

template < class Element, class Key, class Base >
Element const& IRKeySortedBag < Element, Key, Base >::
firstElement () const
{ return ivBase.firstElement ();
}

template < class Element, class Key, class Base >
Element const& IRKeySortedBag < Element, Key, Base >::
lastElement () const
{ return ivBase.lastElement ();
}

template < class Element, class Key, class Base >
Element const& IRKeySortedBag < Element, Key, Base >::
elementAtPosition (IPosition position) const
{ return ivBase.elementAtPosition (position);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
setToLast (ICursor &cursor) const
{ return ivBase.setToLast (cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
setToPrevious (ICursor &cursor) const
{ return ivBase.setToPrevious (cursor);
}

template < class Element, class Key, class Base >
void IRKeySortedBag < Element, Key, Base >::
setToPosition (IPosition position, ICursor &cursor) const
{ ivBase.setToPosition (position, cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
isFirst (ICursor const& cursor) const
{ return ivBase.isFirst (cursor);
}

template < class Element, class Key, class Base >
IBoolean IRKeySortedBag < Element, Key, Base >::
isLast (ICursor const& cursor) const
{ return ivBase.isLast (cursor);
}

