#ifndef _ISCROLL_INL_
#define _ISCROLL_INL_ 0
/*******************************************************************************
* FILE NAME: iscroll.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in iscroll.hpp.                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ISCROLL_
  #undef  _ISCROLL_INL_
  #define _ISCROLL_INL_ 1
  #include <iscroll.hpp>
#endif

#if _ISCROLL_INL_
  #define inline
#endif

/*-------------------------------- IScrollBar --------------------------------*/
inline void  IScrollBar :: setDefaultStyle ( const IScrollBar::Style& style )
  {
  currentDefaultStyle = style;
  }
inline unsigned long  IScrollBar :: minScrollIncrement ( ) const
  {
  return ulClMinScrollIncrement;
  }
inline IScrollBar&  IScrollBar :: setMinScrollIncrement ( unsigned long value )
  {
  ulClMinScrollIncrement = value;
  return *this;
  }
inline IScrollBar&  IScrollBar :: setPageScrollIncrement ( unsigned long value )
  {
  ulClPageScrollIncrement = value;
  return *this;
  }

#endif // _ISCROLL_INL_
