#ifndef _ISIZEEVT_
  #define _ISIZEEVT_
/*******************************************************************************
* FILE NAME: isizeevt.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IResizeEvent - Represents a window resizing event                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IEVENT_
  #include <ievent.hpp>
#endif

/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

// Forward declarations for other classes:
class ISize;


class IResizeEvent : public IEvent {
typedef IEvent
  Inherited;
/*******************************************************************************
* The IResizeEvent class represents an event routed to windows to notify them  *
* of sizing changes (the window has already been sized).  Functions are        *
* provided to return the previous and new window sizes.                        *
*******************************************************************************/
public:
/*-------------------------- Constructor/Destructor ----------------------------
| The only way to construct instances of this class is from an instance of     |
| the IEvent class.                                                            |
------------------------------------------------------------------------------*/
  IResizeEvent ( IEvent& event );
virtual
 ~IResizeEvent ( );

/*----------------------------- Size Information -------------------------------
| The following functions provide a means of getting information about the     |
| sizing change.                                                               |
|   oldSize - Returns the size of the window before it is resized.             |
|   newSize - Returns the size of the window after it is resized.              |
------------------------------------------------------------------------------*/
ISize
  oldSize      ( ) const,
  newSize      ( ) const;
}; // IResizeEvent

/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif /* _ISIZEEVT_ */
