#ifndef _ISTATTXT_INL_
#define _ISTATTXT_INL_ 0
/*******************************************************************************
* FILE NAME: istattxt.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in istattxt.hpp.                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ISTATTXT_
  #undef  _ISTATTXT_INL_
  #define _ISTATTXT_INL_ 1
  #include <istattxt.hpp>
#endif

#if _ISTATTXT_INL_
  #define inline
#endif

/*------------------------------- IStaticText --------------------------------*/
inline void IStaticText :: setDefaultStyle ( IStaticText::Style style )
  {
  currentDefaultStyle = style;
  }
inline IStaticText& IStaticText :: disableFillBackground ( )
  {
  return enableFillBackground(false);
  }
inline IStaticText& IStaticText :: disableUnderscore ( )
  {
  return enableUnderscore(false);
  }
inline IStaticText& IStaticText :: disableStrikeout ( )
  {
  return enableStrikeout(false);
  }
inline IStaticText& IStaticText :: disableHalftone ( )
  {
  return enableHalftone(false);
  }
inline unsigned long IStaticText :: limit ( ) const
  {
  return ulClLimit;
  }

#endif /* _ISTATTXT_INL_ */
