#ifndef _ISTRENUM_
#define _ISTRENUM_
/*******************************************************************************
* FILE NAME: istrenum.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declaration(s) of the class(es):                    *
*     IStringEnum - Placeholder for enumerations related to class IString.      *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

class IStringEnum {
/*******************************************************************************
  The IStringEnum class serves as a repository for enumeration types related
  to the IString class.  These enumeration types are placed here so they can
  easily be shared between code that implements the IString class and the
  IBuffer and IDBCSBuffer classes.
*******************************************************************************/
public:
/*------------------------------ Related Types ---------------------------------
  This class defines the following enumeration types:
    StripMode - Enumeration that defines the mode of operation of various
                functions that strip leading characters, trailing characters,
                or both from IStrings.
    CharType  - Enumeration that defines the various types of characters that
                comprise an IString.
------------------------------------------------------------------------------*/
typedef enum
  {
  leading,
  trailing,
  both
  } StripMode;

typedef enum
  {
  sbcs,
  dbcs1,
  dbcs2
  } CharType;
}; // class IStringEnum

/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif // _ISTRENUM_
