#ifndef _ISWP_INL_
#define _ISWP_INL_ 0
/*******************************************************************************
* FILE NAME: iswp.inl                                                          *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in iswp.hpp.                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ISWP_
  #undef  _ISWP_INL_
  #define _ISWP_INL_ 1
  #include <iswp.hpp>
#endif

#ifndef _IPOINT_
  #include <ipoint.hpp>
#endif

#if _ISWP_INL_
  #define inline
#endif

inline IWindowHandle ISWP :: windowHandle ( ) const
  {
  return this->hwnd;
  }

inline IPoint ISWP :: position ( ) const
  {
  return IPoint( this->x, this->y );
  }

inline ISWP &ISWP :: setPosition ( const IPoint &aPoint )
  {
  this->x = aPoint.x();
  this->y = aPoint.y();
  return *this;
  }

inline ISize ISWP :: size ( ) const
  {
  return ISize( this->cx, this->cy );
  }

inline ISWP &ISWP :: setSize ( const ISize &aSize )
  {
  this->cx = aSize.width();
  this->cy = aSize.height();
  return *this;
  }

inline ISWPArray :: ISWPArray ( ISWP *array, unsigned dimension )
  : p( array ),
    dim( dimension )
  {
  }

inline unsigned long &ISWP :: flags ( )
  {
  return this->fl;
  }

inline unsigned ISWPArray :: size ( ) const
  {
  return this->dim;
  }

inline ISWP &ISWPArray :: operator [] ( unsigned index )
  {
  return p[index];
  }

#endif // _ISWP_INL_
