#ifndef _ITRACE_INL_
#define _ITRACE_INL_ 0
/*******************************************************************************
* FILE NAME: itrace.inl                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   class(es) declared in itrace.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   Licensed Materials - Property of IBM                                       *
*   (C) Copyright IBM Corporation 1992, 1993                                   *
*   All Rights Reserved                                                        *
*   US Government Users Restricted Rights - Use, duplication, or               *
*   disclosure                                                                 *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

#ifndef _ISTRING_
  #include <istring.hpp>
#endif

#ifndef _ITRACE_
  #undef  _ITRACE_INL_
  #define _ITRACE_INL_ 1
  #include <itrace.hpp>
#endif


#if _ITRACE_INL_
  #define inline
#endif

inline void ITrace :: enableWriteLineNumber()
{
  ITrace::iClState |= ITrace::writeLineNumber;
}

inline void ITrace :: disableWriteLineNumber()
{
  ITrace::iClState &= ~ITrace::writeLineNumber;
}


inline IBase::Boolean ITrace :: isWriteLineNumberEnabled()
{
  return (ITrace::iClState & ITrace::writeLineNumber);
}


inline void ITrace::enableTrace()
{
  ITrace::iClState |= ITrace::on;
}

inline void ITrace::disableTrace()
{
  ITrace::iClState &= ~ITrace::on;
}

inline IBase::Boolean ITrace::isTraceEnabled()
{
  return (ITrace::iClState & ITrace::on);
}

inline void ITrace::writeToQueue()
{
 ITrace::iClTraceLocation = ITrace::queue;
}


inline void ITrace::writeToStandardError()
{
   ITrace::iClTraceLocation = ITrace::standardError;
}

inline void ITrace::writeToStandardOutput()
{
   ITrace::iClTraceLocation = ITrace::standardOutput;
}

inline ITrace::Destination ITrace::traceDestination()
{
   return(ITrace::iClTraceLocation);
}

inline void ITrace::enableWritePrefix()
{
  ITrace::iClState |= ITrace::writePrefix;
}

inline void ITrace::disableWritePrefix()
{
  ITrace::iClState &= ~ITrace::writePrefix;
}

inline IBase::Boolean ITrace::isWritePrefixEnabled()
{
  return (ITrace::iClState & ITrace::writePrefix);
}


#endif // _ITRACE_INL_

