#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )

#ifndef __builtin_h
   #define __builtin_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <builtin.h> header file                                         */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #if defined(__EXTENDED__)

      #ifndef __size_t
         #define __size_t
         typedef unsigned int size_t;
      #endif

      void           _Builtin __interrupt( const unsigned int );
      unsigned long  _Builtin __getTIBvalue( const unsigned int );

      #define _interrupt( x )   __interrupt( x )
      #define _getTIBvalue( x ) __getTIBvalue( x )

      double _Builtin __fsin ( double );
      double _Builtin __fcos ( double );
      double _Builtin __fptan ( double );
      double _Builtin __fpatan ( double );
      double _Builtin __facos ( double );
      double _Builtin __fasin ( double );
      double _Builtin __fsincos ( double, double * );
      double _Builtin __fsqrt ( double );
      double _Builtin __fcossin ( double, double * );
      double _Builtin __f2xm1 ( double );
      double _Builtin __fyl2x ( double, double );
      double _Builtin __fyl2xp1 ( double, double );

      #define _fsin( x )         __fsin( (x) )
      #define _fcos( x )         __fcos( (x) )
      #define _fptan( x )        __fptan( (x) )
      #define _fpatan( x )       __fpatan( (x) )
      #define _facos( x )        __facos( (x) )
      #define _fasin( x )        __fasin( (x) )
      #define _fsincos( x, y )   __fsincos( (x), (y) )
      #define _fsqrt( x )        __fsqrt( (x) )
      #define _fcossin( x, y )   __fcossin( (x), (y) )
      #define _f2xm1( x )        __f2xm1( (x) )
      #define _fyl2x( x, y )     __fyl2x( (x), (y) )
      #define _fyl2xp1( x, y )   __fyl2xp1( (x), (y) )

      void           _Builtin __enable( void );
      void           _Builtin __disable( void );
      int            _Builtin __inpb( const unsigned int );
      unsigned short _Builtin __inpw( const unsigned int );
      unsigned long  _Builtin __inpd( const unsigned int );
      int            _Builtin __outpb( const unsigned int, const int );
      unsigned short _Builtin __outpw( const unsigned int, const unsigned short );
      unsigned long  _Builtin __outpd( const unsigned int, const unsigned long );
      unsigned int   _Builtin __clear87( void );
      unsigned int   _Builtin __control87( unsigned int, unsigned int );
      unsigned int   _Builtin __status87( void );

      #ifndef _alloca
         void * _Builtin __alloca( size_t );
         #pragma info( none )
         #define _alloca( x ) __alloca( (x) )
         #define alloca( x ) __alloca( (x) )
         #pragma info( restore )
      #endif

      unsigned char _Builtin __parmdwords( void );

      #define _enable( )              __enable( )
      #define _disable( )             __disable( )
      #define _inp( x )               __inpb( x )
      #define _inpw( x )              __inpw( x )
      #define _inpd( x )              __inpd( x )
      #define _outp( x, y )           __outpb( (x), (y) )
      #define _outpw( x, y )          __outpw( (x), (y) )
      #define _outpd( x, y )          __outpd( (x), (y) )
      #define _clear87( )             __clear87( )
      #define _control87( x, y )      __control87( (x), (y) )
      #define _status87( )            __status87( )

   #endif

   #ifdef __cplusplus
      }
   #endif

#endif

#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
