#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )

#ifndef __errno_h
   #define __errno_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <errno.h> header file                                           */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #ifndef errno
      #ifdef __MULTI__
         int * _Optlink _errno( void );
         #pragma info( none )
         #define errno (*_errno( ))
         #pragma info( restore )
      #else
         extern int errno;
         #pragma info( none )
         #define errno errno
         #pragma info( restore )
      #endif
   #endif

   #ifndef _doserrno
      #ifdef __MULTI__
         int * _Optlink __doserrno( void );
         #pragma info( none )
         #define _doserrno (*__doserrno( ))
         #pragma info( restore )
      #else
         extern int _doserrno;
         #pragma info( none )
         #define _doserrno _doserrno
         #pragma info( restore )
      #endif
   #endif

   /* error codes */

   #define EDOM      1                 /* domain error                       */
   #define ERANGE    2                 /* range error                        */

   #define EBADMODE        3
   #define EBADNAME        4
   #define EISTEMPMEM      5
   #define EBADSHARE       6
   #define EBUFMODE        7
   #define EERRSET         8
   #define EISOPEN         9
   #define ENOTEXIST      10
   #define ENOTINIT       11
   #define ENULLFCB       12
   #define EOUTOFMEM      13
   #define ESMALLBF       14
   #define EEXIST         16
   #define ENOGEN         17
   #define ENOSEEK        19
   #define EBADPOS        20
   #define EBADSEEK       22
   #define ENOENT         23
   #define EACCESS        24
   #define EMFILE         25
   #define ENOCMD         26
   #define EGETANDPUT     28
   #define EPASTEOF       29
   #define ENOTREAD       30
   #define ETOOMANYUNGETC 31
   #define EUNGETEOF      32
   #define EPUTUNGET      33
   #define ECHILD         34
   #define EINTR          35
   #define EINVAL         36
   #define ENOEXEC        37
   #define EAGAIN         38
   #define EBADTYPE       39
   #define ENOTWRITE      40
   #define EPUTANDGET     41
   #define ELARGEBF       42
   #define EBADF          43
   #define EXDEV          44
   #define ENOSPC         45
   #define EMATH          46
   #define EMODNAME       47
   #define EMAXATTR       49
   #define EREADERROR     50
   #define EBADATTR       51

   #define EOS2ERR 60                  /* OS/2 error                         */

   #define ENOMEM  EOUTOFMEM
   #define EACCES  EACCESS

   #ifdef __cplusplus
      }
   #endif

#endif

#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
