#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )

#ifndef __memory_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <memory.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #if defined(__EXTENDED__)
      #define __memory_h

      #ifndef __size_t
         #define __size_t
         typedef unsigned int size_t;
      #endif

      void * _Builtin __memcpy( void *, const void *, size_t );
      void * _Builtin __memchr( const void *, int, size_t );
      int    _Builtin __memcmp( const void *, const void *, size_t );
      void * _Builtin __memset( void *, int, size_t );
      void * _Builtin __memmove( void *, const void *, size_t );

      void * _Optlink memcpy( void *, const void *, size_t );
      void * _Optlink memchr( const void *, int, size_t );
      int    _Optlink memcmp( const void *, const void *, size_t );
      void * _Optlink memset( void *, int, size_t );
      void * _Optlink memmove( void *, const void *, size_t );
      void * _Optlink memccpy( void *, void *, int, unsigned int );
      int    _Optlink memicmp( void *, void *, unsigned int );

      #ifdef __cplusplus
         inline void * memcpy( void * m1, const void * m2, size_t len )
                        { return __memcpy( m1, m2, len ); }
         inline void * memchr( const void * m, int ch, size_t len )
                        { return __memchr( m, ch, len ); }
         inline int    memcmp( const void * m1, const void * m2, size_t len )
                        { return __memcmp( m1, m2, len ); }
         inline void * memset( void * m, int ch, size_t len )
                        { return __memset( m, ch, len ); }
         inline void * memmove( void * m1, const void * m2, size_t len )
                        { return __memmove( m1, m2, len ); }
      #else
         #pragma info( none )
         #define memcpy( x, y, z )  __memcpy( (x), (y), (z) )
         #define memchr( x, y, z )  __memchr( (x), (y), (z) )
         #define memcmp( x, y, z )  __memcmp( (x), (y), (z) )
         #define memset( x, y, z )  __memset( (x), (y), (z) )
         #define memmove( x, y, z ) __memmove( (x), (y), (z) )
         #pragma info( restore )
      #endif

      #define _fmemcpy( x, y, z )     memcpy( (x), (y), (z) )
      #define _fmemchr( x, y, z )     memchr( (x), (y), (z) )
      #define _fmemcmp( x, y, z )     memcmp( (x), (y), (z) )
      #define _fmemset( x, y, z )     memset( (x), (y), (z) )
      #define _fmemccpy( w, x, y, z ) memccpy( (w), (x), (y), (z) )
      #define _fmemicmp( x, y, z )    memicmp( (x), (y), (z) )

   #endif

   #ifdef __cplusplus
      }
   #endif

#endif

#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
