#ifndef __new_h
   #define __new_h

   /********************************************************************/
   /*  <new.h> header file                                             */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1992, 1993 */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/
   #include <stddef.h>

   // Definition of C++ storage management -- new & delete

   void (*set_new_handler (void(*)()))();
   #ifdef __MULTI__
      void (*_set_mt_new_handler (void(*)()))();
   #endif

   // The standard favourites

   #ifndef __DEBUG_ALLOC__
      void *operator new(size_t);
      void operator delete(void *);

      void *operator new(size_t, void *);
   #else
      #include <stdlib.h>

      void * operator new(size_t, const char*, size_t);
      void operator delete(void *, const char*, size_t);

      void *operator new(size_t, const char*, size_t, void *);
   #endif

#endif
