#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )

#ifndef __process_h
   #define __process_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <process.h> header file                                         */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #if defined(__EXTENDED__)

      /* Modeflag values for spawnxx routines */

      #define P_WAIT          0
      #define P_NOWAIT        1
      #define P_OVERLAY       2

      /* Action codes used with cwait() */

      #define WAIT_CHILD      0
      #define WAIT_GRANDCHILD 1

      /* function prototypes */

      void _Optlink abort( void );
      void _Optlink exit( int );
      int  _Optlink system( const char * );

      void _Optlink _exit( int );

      int  _Optlink _execl( char *, char *, ... );
      int  _Optlink _execle( char *, char *, ... );
      int  _Optlink _execlp( char *, char *, ... );
      int  _Optlink _execlpe( char *, char *, ... );
      int  _Optlink _spawnl( int, char *, char *, ... );
      int  _Optlink _spawnle( int, char *, char *, ... );
      int  _Optlink _spawnlp( int, char *, char *, ... );
      int  _Optlink _spawnlpe( int, char *, char *, ... );

      int  _Optlink  execl( char *, char *, ... );
      int  _Optlink  execle( char *, char *, ... );
      int  _Optlink  execlp( char *, char *, ... );
      int  _Optlink  execlpe( char *, char *, ... );
      int  _Optlink  spawnl( int, char *, char *, ... );
      int  _Optlink  spawnle( int, char *, char *, ... );
      int  _Optlink  spawnlp( int, char *, char *, ... );
      int  _Optlink  spawnlpe( int, char *, char *, ... );

      #pragma map( _execl   , "_execl_ansi"    )
      #pragma map( _execle  , "_execle_ansi"   )
      #pragma map( _execlp  , "_execlp_ansi"   )
      #pragma map( _execlpe , "_execlpe_ansi"  )
      #pragma map( _spawnl  , "_spawnl_ansi"   )
      #pragma map( _spawnle , "_spawnle_ansi"  )
      #pragma map( _spawnlp , "_spawnlp_ansi"  )
      #pragma map( _spawnlpe, "_spawnlpe_ansi" )

      #pragma map(  execl   , "_execl_ansi"    )
      #pragma map(  execle  , "_execle_ansi"   )
      #pragma map(  execlp  , "_execlp_ansi"   )
      #pragma map(  execlpe , "_execlpe_ansi"  )
      #pragma map(  spawnl  , "_spawnl_ansi"   )
      #pragma map(  spawnle , "_spawnle_ansi"  )
      #pragma map(  spawnlp , "_spawnlp_ansi"  )
      #pragma map(  spawnlpe, "_spawnlpe_ansi" )

      int  _Optlink _cwait( int *, int, int );
      int  _Optlink _execv( char *, char ** );
      int  _Optlink _execve( char *, char **, char ** );
      int  _Optlink _execvp( char *, char ** );
      int  _Optlink _execvpe( char *, char **, char ** );
      int  _Optlink _getpid( void );
      int  _Optlink _spawnv( int, char *, char ** );
      int  _Optlink _spawnve( int, char *, char **, char ** );
      int  _Optlink _spawnvp( int, char *, char ** );
      int  _Optlink _spawnvpe( int, char *, char **, char ** );
      int  _Optlink _wait( int * );

      int  _Optlink  cwait( int *, int, int );
      int  _Optlink  execv( char *, char ** );
      int  _Optlink  execve( char *, char **, char ** );
      int  _Optlink  execvp( char *, char ** );
      int  _Optlink  execvpe( char *, char **, char ** );
      int  _Optlink  getpid( void );
      int  _Optlink  spawnv( int, char *, char ** );
      int  _Optlink  spawnve( int, char *, char **, char ** );
      int  _Optlink  spawnvp( int, char *, char ** );
      int  _Optlink  spawnvpe( int, char *, char **, char ** );
      int  _Optlink  wait( int * );

      #pragma map( cwait   , "_cwait"    )
      #pragma map( execv   , "_execv"    )
      #pragma map( execve  , "_execve"   )
      #pragma map( execvp  , "_execvp"   )
      #pragma map( execvpe , "_execvpe"  )
      #pragma map( getpid  , "_getpid"   )
      #pragma map( spawnv  , "_spawnv"   )
      #pragma map( spawnve , "_spawnve"  )
      #pragma map( spawnvp , "_spawnvp"  )
      #pragma map( spawnvpe, "_spawnvpe" )
      #pragma map( wait    , "_wait"     )

      #ifdef __MULTI__
         int  _Optlink _beginthread( void ( * _Optlink __thread )( void * ), void *, unsigned, void * );
         void _Optlink _endthread( void );
         void ** _Optlink _threadstore( void );
      #endif

   #endif

   #ifdef __cplusplus
      }
   #endif

#endif

#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
