#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )

#ifndef __string_h
   #define __string_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <string.h> header file                                          */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #ifndef __size_t
      #define __size_t
      typedef unsigned int size_t;
   #endif

   #ifndef NULL
      #if (defined(__EXTENDED__)  || defined( __cplusplus ))
         #define NULL 0
      #else
         #define NULL ((void *)0)
      #endif
   #endif

   char * _Builtin __strcat( char *, const char * );
   char * _Builtin __strchr( const char *, int );
   int    _Builtin __strcmp( const char *, const char * );
   char * _Builtin __strcpy( char*, const char * );
   size_t _Builtin __strlen( const char * );
   char * _Builtin __strncat( char *, const char *, size_t );
   int    _Builtin __strncmp( const char *, const char *, size_t );
   char * _Builtin __strncpy( char *, const char *, size_t );
   char * _Builtin __strrchr( const char *, int );
   char * _Optlink strcat( char *, const char * );
   char * _Optlink strchr( const char *, int );
   int    _Optlink strcmp( const char *, const char * );
   char * _Optlink strcpy( char *, const char * );
   size_t _Optlink strlen( const char * );
   char * _Optlink strncat( char *, const char *, size_t );
   int    _Optlink strncmp( const char *, const char *, size_t );
   char * _Optlink strncpy( char *, const char *, size_t );
   char * _Optlink strrchr( const char *, int );
   int    _Optlink strcoll( const char *, const char * );
   size_t _Optlink strcspn( const char *, const char * );
   char * _Optlink strerror( int );
   char * _Optlink strpbrk( const char *, const char * );
   size_t _Optlink strspn( const char *, const char * );
   char * _Optlink strstr( const char *, const char * );
   char * _Optlink strtok( char*, const char * );
   size_t _Optlink strxfrm( char *, const char *, size_t );

   #ifdef __cplusplus
      inline char * strcat( char * s1, const char * s2 )
                     { return __strcat( s1, s2 ); }
      inline char * strchr( const char * s, int ch )
                     { return __strchr( s, ch ); }
      inline int    strcmp( const char * s1, const char * s2 )
                     { return __strcmp( s1, s2 ); }
      inline char * strcpy( char * s1, const char * s2 )
                     { return __strcpy( s1, s2 ); }
      inline size_t strlen( const char * s )
                     { return __strlen( s ); }
      inline char * strncat( char * s1, const char * s2, size_t len )
                     { return __strncat( s1, s2, len ); }
      inline int    strncmp( const char * s1, const char * s2, size_t len )
                     { return __strncmp( s1, s2, len ); }
      inline char * strncpy( char * s1, const char * s2, size_t len )
                     { return __strncpy( s1, s2, len ); }
      inline char * strrchr( const char * s1, int ch )
                     { return __strrchr( s1, ch ); }
   #else
      #pragma info( none )
      #define strcat( x, y )     __strcat( (x), (y) )
      #define strchr( x, y )     __strchr( (x), (y) )
      #define strcmp( x, y )     __strcmp( (x), (y) )
      #define strcpy( x, y )     __strcpy( (x), (y) )
      #define strlen( x )        __strlen( (x) )
      #define strncat( x, y, z ) __strncat( (x), (y), (z) )
      #define strncmp( x, y, z ) __strncmp( (x), (y), (z) )
      #define strncpy( x, y, z ) __strncpy( (x), (y), (z) )
      #define strrchr( x, y )    __strrchr( (x), (y) )
      #pragma info( restore )
   #endif

   #ifndef __memory_h
      #define __memory_h

      void * _Builtin __memcpy( void *, const void *, size_t );
      void * _Builtin __memchr( const void *, int, size_t );
      int    _Builtin __memcmp( const void *, const void *, size_t );
      void * _Builtin __memset( void *, int, size_t );
      void * _Builtin __memmove( void *, const void *, size_t );

      void * _Optlink memcpy( void *, const void *, size_t );
      void * _Optlink memchr( const void *, int, size_t );
      int    _Optlink memcmp( const void *, const void *, size_t );
      void * _Optlink memset( void *, int, size_t );
      void * _Optlink memmove( void *, const void *, size_t );

      #ifdef __cplusplus
         inline void * memcpy( void * m1, const void * m2, size_t len )
                        { return __memcpy( m1, m2, len ); }
         inline void * memchr( const void * m, int ch, size_t len )
                        { return __memchr( m, ch, len ); }
         inline int    memcmp( const void * m1, const void * m2, size_t len )
                        { return __memcmp( m1, m2, len ); }
         inline void * memset( void * m, int ch, size_t len )
                        { return __memset( m, ch, len ); }
         inline void * memmove( void * m1, const void * m2, size_t len )
                        { return __memmove( m1, m2, len ); }
      #else
         #pragma info( none )
         #define memcpy( x, y, z )  __memcpy( (x), (y), (z) )
         #define memchr( x, y, z )  __memchr( (x), (y), (z) )
         #define memcmp( x, y, z )  __memcmp( (x), (y), (z) )
         #define memset( x, y, z )  __memset( (x), (y), (z) )
         #define memmove( x, y, z ) __memmove( (x), (y), (z) )
         #pragma info( restore )
      #endif

      #if defined( __EXTENDED__ )

         void * _Optlink memccpy( void *, void *, int, unsigned int );
         int    _Optlink memicmp( void *, void *, unsigned int );

         #pragma info( none )
         #define _fmemcpy( x, y, z )     memcpy( (x), (y), (z) )
         #define _fmemchr( x, y, z )     memchr( (x), (y), (z) )
         #define _fmemcmp( x, y, z )     memcmp( (x), (y), (z) )
         #define _fmemset( x, y, z )     memset( (x), (y), (z) )
         #define _fmemccpy( w, x, y, z ) memccpy( (w), (x), (y), (z) )
         #define _fmemicmp( x, y, z )    memicmp( (x), (y), (z) )
         #pragma info( restore )

      #endif

   #endif

   #if defined(__EXTENDED__)

      char * _Optlink strdup( const char * );
      int    _Optlink stricmp( const char *, const char * );
      char * _Optlink strlwr( char * );
      int    _Optlink strnicmp( const char *, const char *, size_t );
      char * _Optlink strupr( char * );

      int    _Optlink strcmpi( const char *, const char * );
      char * _Optlink strrev( char * );
      char * _Optlink strset( char *, int );
      char * _Optlink strnset( char *, int, size_t );
      char * _Optlink _strerror( char * );

      #define _fmemmove( x, y, z )  memmove( (x), (y), (z) )
      #define _fstrcat( x, y )      strcat( (x), (y) )
      #define _fstrchr( x, y )      strchr( (x), (y) )
      #define _fstrcmp( x, y )      strcmp( (x), (y) )
      #define _fstrcpy( x, y )      strcpy( (x), (y) )
      #define _fstrlen( x )         strlen( (x) )
      #define _fstrncat( x, y, z )  strncat( (x), (y), (z) )
      #define _fstrncmp( x, y, z )  strncmp( (x), (y), (z) )
      #define _fstrncpy( x, y, z )  strncpy( (x), (y), (z) )
      #define _fstrrchr( x, y )     strrchr( (x), (y) )

      size_t _Optlink _fstrcspn( const char *, const char * );
      char * _Optlink _fstrdup( const char * );
      char * _Optlink _nstrdup( const char * );
      int    _Optlink _fstricmp( const char *, const char * );
      char * _Optlink _fstrlwr( char * );
      int    _Optlink _fstrnicmp( const char *, const char *, size_t );
      char * _Optlink _fstrnset( char *, int, size_t );
      char * _Optlink _fstrpbrk( const char *, const char * );
      char * _Optlink _fstrrev( char * );
      char * _Optlink _fstrset( char *, int );
      size_t _Optlink _fstrspn( const char *, const char * );
      char * _Optlink _fstrstr( const char *, const char * );
      char * _Optlink _fstrtok( char*, const char * );
      char * _Optlink _fstrupr( char * );

      #pragma map( _fstrcspn , "strcspn"  )
      #pragma map( _fstrdup  , "strdup"   )
      #pragma map( _nstrdup  , "strdup"   )
      #pragma map( _fstricmp , "stricmp"  )
      #pragma map( _fstrlwr  , "strlwr"   )
      #pragma map( _fstrnicmp, "strnicmp" )
      #pragma map( _fstrnset , "strnset"  )
      #pragma map( _fstrpbrk , "strpbrk"  )
      #pragma map( _fstrrev  , "strrev"   )
      #pragma map( _fstrset  , "strset"   )
      #pragma map( _fstrspn  , "strspn"   )
      #pragma map( _fstrstr  , "strstr"   )
      #pragma map( _fstrtok  , "strtok"   )
      #pragma map( _fstrupr  , "strupr"   )

   #endif

   #ifdef __cplusplus
      }
   #endif

#endif

#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
