#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )

#ifndef __time_h
   #define __time_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   /********************************************************************/
   /*  <time.h> header file                                            */
   /*                                                                  */
   /*  Licensed Materials - Property of IBM                            */
   /*                                                                  */
   /*  IBM C/C++ Tools Version 2.01                                    */
   /*  Copyright (C) International Business Machines Corp., 1991,1993  */
   /*  All rights reserved                                             */
   /*                                                                  */
   /*  US Government Users Restricted Rights -                         */
   /*  Use, duplication, or disclosure restricted                      */
   /*  by GSA ADP Schedule Contract with IBM Corp.                     */
   /*                                                                  */
   /********************************************************************/

   #ifndef NULL
      #if (defined(__EXTENDED__)  || defined( __cplusplus ))
         #define NULL 0
      #else
         #define NULL ((void *)0)
      #endif
   #endif

   #define CLOCKS_PER_SEC 1000

   #ifndef __size_t
      #define __size_t
      typedef unsigned int size_t;
   #endif

   typedef unsigned long clock_t;

   #ifndef __time_t
      #define __time_t
      typedef long time_t;
   #endif

   struct tm
      {
      int tm_sec;      /* seconds after the minute [0-61]        */
      int tm_min;      /* minutes after the hour [0-59]          */
      int tm_hour;     /* hours since midnight [0-23]            */
      int tm_mday;     /* day of the month [1-31]                */
      int tm_mon;      /* months since January [0-11]            */
      int tm_year;     /* years since 1900                       */
      int tm_wday;     /* days since Sunday [0-6]                */
      int tm_yday;     /* days since January 1 [0-365]           */
      int tm_isdst;    /* Daylight Saving Time flag              */
      };

   clock_t     _Optlink clock( void );
   double      _Optlink difftime( time_t, time_t );
   time_t      _Optlink mktime( struct tm * );
   time_t      _Optlink time( time_t * );
   char *      _Optlink asctime( const struct tm * );
   char *      _Optlink ctime( const time_t * );
   struct tm * _Optlink gmtime( const time_t * );
   struct tm * _Optlink localtime( const time_t * );
   size_t      _Optlink strftime( char *, size_t, const char *, const struct tm * );
   void        _Optlink _tzset( void );
   char *      _Optlink _strdate( char * );
   char *      _Optlink _strtime( char * );

   extern int  _daylight; /* non-zero if daylight savings time is used */
   extern long _timezone; /* difference in seconds between UCT and local time */
   extern char *_tzname[2]; /* std/daylight savings time zone names  */

   #pragma info( none )
   #define difftime( t1, t0 ) ((double)((t1) - (t0)))
   #define ctime( t ) (asctime(localtime(t)))
   #pragma info( restore )

   #ifndef __ANSI__

      #define CLK_TCK  CLOCKS_PER_SEC

      #ifndef __SAA_L2__

         #if defined(__EXTENDED__)

            #define daylight _daylight
            #define tzname   _tzname
            #define tzset( ) _tzset( )

         #endif

      #endif

   #endif

   #ifdef __cplusplus
      }
   #endif

#endif

#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
