@echo off
@REM
@REM Building C++ DLL
@REM
@REM Method 2 Sample program
@REM
@REM

@REM===========================================
@REM  STEP 1
@REM
@REM  Compiling Objects needed to build the DLL
@REM===========================================

@erase *.obj *.dll *.lib *.map *.exe > NUL 2>&1
echo Compiling stack.CPP
icc /c /O+ /Ge- /Q stack.CPP
IF ERRORLEVEL 1 GOTO RPTERR

@REM===========================================
@REM  STEP 2
@REM
@REM  Compiling the tempinc file in the TEMPINC
@REM  directory
@REM===========================================

echo Changing to TEMPINC directory
cd tempinc

@echo Compiling the tempinc file stk.c

icc /c /O+ /Ge- /Q  /ft- /W2 stk.CPP

@REM===========================================
@REM  STEP 3
@REM
@REM  Copy the tempinc objects into the DLL
@REM  building directory
@REM===========================================

echo Copying tempinc file stk.c
copy stk.obj ..
cd ..

@REM===========================================
@REM  STEP 4
@REM
@REM  Run cppfilt.exe on all the objects
@REM  using -b -p
@REM===========================================

CPPFILT -b -p  *.OBJ > stack.tmp

@REM===========================================
@REM  STEP 5
@REM
@REM  Edit the stack.tmp file to exclude any
@REM  symbols you may not want to export
@REM  Add in the standard def file information
@REM
@REM===========================================

echo Adding in the DEF file control information
type basic.def stack.tmp > stack.def

@REM===========================================
@REM  STEP 6
@REM
@REM Building DLL
@REM===========================================

echo Creating DLL
icc  /Tdp /b"/NOLOGO /NOE /NOI" /festack.dll stack stack.DEF
IF ERRORLEVEL 1 GOTO RPTERR

@REM========================================
@REM  STEP 7
@REM
@REM Building of Import Library
@REM========================================

echo "Creating import library from DLL
IMPLIB /NOLOGO stack.LIB stack.DLL
IF ERRORLEVEL 1 GOTO RPTERR

@REM===========================================
@REM Compiling the application
@REM
@REM===========================================

echo Compiling  main.CPP
icc /O+ /Q /Ft- /c main.CPP

@REM============================================================
@REM  STEP 8
@REM
@REM  Building the EXE - Erase tempinc objects that were already
@REM                     linked into the DLL
@REM                     Linking the application with ICC
@REM============================================================

echo Erasing all tempinc objects that were already included in the DLL
erase tempinc\stk.obj
erase tempinc\stk.cpp

echo Linking the application with the import library

icc /B/MAP /Tdp  /Q main stack.lib

@REM==== Note that instead of erasing the tempinc files, you may
@REM==== also use the /ft- flag to ignore the tempinc directory


@REM====================
@REM  Running the EXE
@REM====================

main
IF ERRORLEVEL 1 GOTO RPTERR
Goto end

:RPTERR
echo ERROR has occurred
:END
