#include <idmprov.hpp>
#include <idmitem.hpp>
#include <idmevent.hpp>

class ABitmapItem : public IDMItem {
/*******************************************************************************
* Objects of this class provide "bitmap control" drop behavior when a          *
* source bitmap file is dropped on a bitmap control properly configured        *
* with a target handler and a ABitmapProvider.                                 *
*******************************************************************************/
public:
/*------------------------------- Constructor ----------------------------------
| Objects of this class are constructed from a generic item handle.            |
------------------------------------------------------------------------------*/
  ABitmapItem ( const IDMItem::Handle &item );

/*------------------------------ Drop Behavior ---------------------------------
| targetDrop - Take the dropped file, create a PM bitmap object,               |
|              and set it into the target window.                              |
------------------------------------------------------------------------------*/
virtual Boolean
  targetDrop ( IDMTargetDropEvent & );
};

class ABitmapProvider : public IDMItemProviderFor< ABitmapItem > {
/*******************************************************************************
* Objects of this class are attached to bitmap controls in order to have       *
* ABitmapItem objects created when a bitmap file is dropped on such a          *
* control.                                                                     *
*******************************************************************************/
public:
/*------------------------------- Target Enter ---------------------------------
| provideEnterSupport - Verify that we're dealing with a bitmap object before  |
|                       allowing a drop.                                       |
------------------------------------------------------------------------------*/
virtual Boolean
  provideEnterSupport ( IDMTargetEnterEvent &event );
};
