#ifndef AHELLOWINDOW_HPP
#define AHELLOWINDOW_HPP
/******************************************************************************/
/* HELLO WORLD SAMPLE PROGRAM - Version 2: Class Header (AHELLOW2.HPP)        */
/*                                                                            */
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1992,1993. */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/
// NOTE: WE RECOMMEND USING A FIXED SPACE FONT TO LOOK AT THE SOURCE

#include <iframe.hpp>                     //Include the IFrameWindow class
                                          // header

//**************************************************************************
// Class:   AHelloWindow                                                   *
//                                                                         *
// Purpose: Main window for the C++ Hello World sample application.        *
//          It is a subclass of IFrameWindow.                              *
//                                                                         *
//**************************************************************************
class AHelloWindow : public IFrameWindow
{
  public:                               //Define the public Information
    AHelloWindow(unsigned long windowId);//Constructor for this class

  private:                              //Define the private Information
    IStaticText   * hello;              //Define a Static Text Control to
                                        //  keep the "Hello, World" text
                                        //  and as the client window
    IInfoArea     * infoArea;           //Define an Information Area          v2
                                        //  Control to create an information   .
                                        //  area beneath the client area      v2
};
#endif
