#ifndef AEARTHWINDOW_HPP
#define AEARTHWINDOW_HPP
/******************************************************************************/
/* HELLO WORLD SAMPLE PROGRAM - Version 6: AEarthWindow Header (AEARTHW6.HPP) */
/*                                                                            */
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1992,1993. */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

//**************************************************************************
// The entire file was created at version 5                                *
//**************************************************************************

#include <istattxt.hpp>                 //IStaticText Class Header
#include <ipainhdr.hpp>                 //IPaintHandler Class Header

//**************************************************************************
// Class:   AHelloWindow                                                   *
//                                                                         *
// Purpose: "Earth" window for the C++ Hello World sample application.     *
//          It is a subclass of IStaticText & IPaintHandler.               *
//                                                                         *
//**************************************************************************
class AEarthWindow : public IStaticText, public IPaintHandler
{
  public:
    AEarthWindow(unsigned long windowId,//AEarthWindow Constructor
      IWindow * parentownerWindow,      //  Parent/Owner Window
      const IRectangle& rect=IRectangle()); //  Origin/Size Rectangle

    Boolean paintWindow(IPaintEvent&) ; //Handle the paint window event
};
#endif
