#ifndef AHELLOWINDOW_H
#define AHELLOWINDOW_H
/******************************************************************************/
/* HELLO WORLD SAMPLE PROGRAM - Version 6: Symbolic Definitions (AHELLOW6.H)  */
/*                                                                            */
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1992,1993. */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/
// NOTE: WE RECOMMEND USING A FIXED SPACE FONT TO LOOK AT THE SOURCE
//**************************************************************************
// window ids - used by IWindow constructors (eg IStaticText, AHelloWindow)*
//**************************************************************************
#define WND_MAIN         0x1000         //Main Window ID

#define WND_HELLO        0x1010         //Hello World Window ID
#define WND_INFO         0x1012         //Information Area                    v2
#define WND_STATUS       0x1011         //Status Line Window ID               v3
#define WND_TEXTDIALOG   0x1013         //Text Dialog Window ID               v4
#define WND_EARTH        0x1014         //Earth Window ID                     v5
#define WND_CANVAS       0x1020         //Canvas Window ID                    v5
#define WND_BUTTONS      0x1021         //Button Canvas Window ID             v4
#define WND_POPUP        0x1030         //Popup Menu Window ID                v6
#define WND_HCANVAS      0x1040         //Hello Canvas Window ID              v5
#define WND_LISTBOX      0x1050         //List Box Window ID                  v5
#define WND_STATUSCANVAS 0x1060         //Status Line Canvas Window ID        v6         v6
#define WND_TIME         0x1061         //Status Line Time Window ID           .         v6
#define WND_DATE         0x1062         //Status Line Date Window ID          v6          v6

#define WND_COLOR        0x1070         //Color Window                        v6          v6
#define WND_COLOR_NOTE   0x1071         //NoteBook used in Color Window       v6          v6

#define WND_LIST_COLOR   0x1080         //List Box Color                      v6
#define WND_LWHITE       0x1081         //White                                .
#define WND_LBLACK       0x1082         //Black                                .
#define WND_LBLUE        0x1083         //Blue                                 .
#define WND_LRED         0x1084         //Red                                  .
#define WND_LPINK        0x1085         //Pink                                 .
#define WND_LGREEN       0x1086         //Green                                .
#define WND_LCYAN        0x1087         //Cyan                                 .
#define WND_LYELLOW      0x1088         //Yellow                               .
#define WND_LAPPLY       0x1089         //Apply Button                         .
#define WND_LCANCEL      0x108a         //Cancel Button                       v6

#define WND_STATIC_COLOR 0x1090         //Static Color                        v6
#define WND_SWHITE       0x1091         //White                                .
#define WND_SBLACK       0x1092         //Black                                .
#define WND_SBLUE        0x1093         //Blue                                 .
#define WND_SRED         0x1094         //Red                                  .
#define WND_SPINK        0x1095         //Pink                                 .
#define WND_SGREEN       0x1096         //Green                                .
#define WND_SCYAN        0x1097         //Cyan                                 .
#define WND_SYELLOW      0x1098         //Yellow                               .
#define WND_SAPPLY       0x1099         //Apply Button                         .
#define WND_SCANCEL      0x109a         //Cancel Button                       v6

#define WND_DEMO_SPEED   0x10a0         //Demo Speed Window                   v6
#define WND_DEMO_CLIENT  0x10a1         //Demo Speed Client                    .
#define WND_DEMO_LABEL1  0x10a2         //Demo Speed Label                     .
#define WND_DEMO_LABEL2  0x10a3         //Demo Speed Label                     .
#define WND_DEMO_BUTTONS 0x10a4         //Demo Speed Buttons                   .
#define WND_DEMO_SLIDER  0x10a5         //Demo Slider                          .
#define WND_DEMO_APPLY   0x10a6         //Apply Button                         .
#define WND_DEMO_CANCEL  0x10a7         //Cancel Button                       v6


//**************************************************************************  v2
// string ids - used to relate resources to IStaticText and ITitle         *   .
//**************************************************************************  v2
#define STR_HELLO        0x1200         //Hello World String ID               v2
#define STR_INFO         0x1220         //Info String ID                      v2
#define STR_INFODLG      0x1221         //Info String ID                      v4
#define STR_CENTER       0x1230         //Center Alignment Status String ID   v3
#define STR_LEFT         0x1231         //Left Alignment Status String ID      .
#define STR_RIGHT        0x1232         //Right Alignment Status String ID    v3
#define STR_CENTERB      0x1240         //Center Button String ID             v4
#define STR_LEFTB        0x1241         //Left Button String ID                .
#define STR_RIGHTB       0x1242         //Right Button String ID              v4
#define STR_HELPB        0x1243         //Help Button String ID               v5
#define STR_HTITLE       0x1250         //Help Window Title                   v5
#define STR_FILEDLGT     0x1260         //File Dialog Title String ID         v6
#define STR_FONTDLGT     0x1261         //Font Dialog Title String ID          .
#define STR_MSGTXT       0x1270         //Message Text String ID              v6

#define STR_WHITE        0x1280         //White String ID                     v6
#define STR_BLACK        0x1281         //Black String ID                      .
#define STR_BLUE         0x1282         //Blue String ID                       .
#define STR_RED          0x1283         //Red String ID                        .
#define STR_PINK         0x1284         //Pink String ID                       .
#define STR_GREEN        0x1285         //Green String ID                      .
#define STR_CYAN         0x1286         //Cyan String ID                       .
#define STR_YELLOW       0x1287         //Yellow String ID                     .
#define STR_LIST_COLOR   0x1290         //List Box Color                       .
#define STR_STATIC_COLOR 0x1291         //Static Text Color                    .
#define STR_APPLY        0x1292         //Apply                                .
#define STR_CANCEL       0x1293         //Cancel                               .
#define STR_DEMO_LABEL1  0x12a0         //Demo Speed Label                     .
#define STR_DEMO_LABEL2  0x12a1         //Demo Speed Label                    v6

//**************************************************************************  v3
// menu ids - used on relate command ID to Menu Items and Function Keys    *   .
//**************************************************************************   .
#define MI_ALIGNMENT     0x1500         //Alignment Menu ID                    .
#define MI_CENTER        0x1501         //Center Menu ID                       .
#define MI_LEFT          0x1502         //Left Menu ID                         .
#define MI_RIGHT         0x1503         //Right Menu ID                       v3
#define MI_EDIT          0x1504         //Edit Menu ID                        v4
#define MI_TEXT          0x1505         //Text Menu ID                        v4
#define MI_COLOR         0x1506         //Color Menu Item ID                  v6
#define MI_FONT          0x1507         //Font Menu Item ID                   v6
#define MI_HELP          0x1510         //Help Menu ID                        v4
#define MI_GENERAL_HELP  0x1511         //General Help                        v5
#define MI_FILE          0x1520         //File Menu ID                        v6
#define MI_OPEN          0x1521         //File Open Menu ID                   v6
#define MI_READ_PROFILE  0x1522         //File Read Profile Menu ID           v6
#define MI_UPDATE_PROFILE 0x1523        //File Update Profile Menu ID         v6
#define MI_DEMO          0x1530         //Demo Menu ID                        v6
#define MI_DEMO_START    0x1531         //Start Demo Menu ID                   .
#define MI_DEMO_STOP     0x1532         //Stop Demo  Menu ID                   .
#define MI_DEMO_SPEED    0x1533         //Demo Speed Menu ID                  v6

//**************************************************************************  v4
// dialog ids - used to relate dialog fields to controls/commands          *   .
//**************************************************************************   .
#ifndef DID_OK                          //                                     .
#define DID_OK           0x0001         //OK Button (Defined by os/2)          .
#endif                                  //                                     .
#ifndef DID_CANCEL                      //                                     .
#define DID_CANCEL       0x0002         //Cancel Button (Defined by os/2)      .
#endif                                  //                                     .
#define DID_ENTRY        0x1603         //Dialog Entry Field ID                .
#define DID_STATIC       0x1604         //Dialog Static Text                  v4

//**************************************************************************  v5
// help ids - used to relate resources to IHelp Class                      *   .
//**************************************************************************   .
#define HELP_TABLE       0x1800         //Help Table ID                        .
#define SUBTABLE_MAIN    0x1801         //Help Subtable for Main Window        .
#define SUBTABLE_DIALOG  0x1802         //Help Subtable for Dialog Window     v5
#define SUBTABLE_COLOR   0x1803         //Help Subtable for Color Window      v6
#define SUBTABLE_SPEED   0x1804         //Help Subtable for Speed Window      v6
#endif
