#ifndef ASPEEDWINDOW_HPP
#define ASPEEDWINDOW_HPP
/******************************************************************************/
/* HELLO WORLD SAMPLE PROGRAM - Version 6: ASpeedWindow Class  (ASPEEDW6.HPP) */
/*                                                                            */
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1992,1993. */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

//**************************************************************************
// The entire file was created at version 6                                *
//**************************************************************************

#include <iframe.hpp>                   //IFrameWindow Class (Parent)
#include <icmdhdr.hpp>                  //ICommandHandler (Parent)

class IEntryField;
class IMultiCellCanvas;
class IRadioButton;
class IPushButton;
class IListBox;
class ISlider;
class AHelloWindow;
class IMultiCellCanvas;

//**************************************************************************
// Class:   ASpeedWindow                                                   *
//                                                                         *
// Purpose: A secondary window for the C++ Hello World sample application. *
//          It is a subclass of IFrameWindow, ICommandHandler              *
//                                                                         *
//**************************************************************************
class ASpeedWindow : public IFrameWindow, public ICommandHandler
{
public:
  ASpeedWindow (
    AHelloWindow * demoWindow,          //Target of Speed Changes
    IWindow * ownerWnd);                //Onwer Window
  ~ASpeedWindow();

protected:
  virtual Boolean
    command(ICommandEvent& cmdevt);     //Process the command events

  virtual Boolean apply();              //Apply Changes

private:
  AHelloWindow     * target;            //Target Window for Color Changes
  IMultiCellCanvas * clientWindow;      //Client Area
  ISetCanvas       * buttons;           //Button Canvas
  IPushButton      * applyButton;       //Static Apply Button
  IPushButton      * cancelButton;      //Static Cancel Button
  ISlider          * slider;            //Slider to set speed
  IStaticText      * label1;            //Label for Slider
  IStaticText      * label2;            //Label for Slider

}; // ASpeedWindow
#endif
