#include <iapp.hpp>                     //IApplication Class
#include <iframe.hpp>                   //IFrameWindow Class
#include <icmdhdr.hpp>                  //ICommandHandler & ICommandEvent
#include <istattxt.hpp>                 //IStaticText Class
#include <istring.hpp>                  //IString Class

#define WND_MAIN         5000           //Main Window Id
#define MI_CLOSE         5001           //Command Id

class AWindow : public IFrameWindow,    //Define AWindow Class from
                public ICommandHandler  //  IFrameWindow & ICommandHandler
{
public:
  AWindow(unsigned long windowId)       //Define AWindow Constructor
    : IFrameWindow (                    //Call IFrameWindow constructor
      IFrameWindow::defaultStyle()      //  Use default styles plus
      | IFrameWindow::menuBar,          //  Get Menu Bar from Resource File
      windowId)                         //  Main Window ID
  {
    IString aString("Simple Example");  //Create text string for static text
    IStaticText * staticText=new        //Create Static Text Control
      IStaticText(5002, this, this);    //  Pass in myself as parent & owner
    staticText->setText(aString);       //Set text in Static Text Control
    handleEventsFor(this);              //Set self as command event handler
    setClient(staticText);              //Set button control in Client Area
    setFocus();                         //Set focus to main window
    show();                             //Set to show main window
  } /* end AWindow :: AWindow(...) */

  Boolean command(ICommandEvent& cEvent)//Define command member function
  {
    if (cEvent.commandId() == MI_CLOSE) //Is Command Event Id = Close Id
    {                                   //  Yes, the command is close
      close();                          //  Let's close the main window
      return true;                      //  Normally, you would return true
    };                                  //  to indicate command processed
    return false;                       //Return Command not Processed
  } /* end AWindow :: command(...) */
};                                      // End of AWindow class definition

void main()                             //Main Procedure with no parameters
{
  AWindow mainWindow(WND_MAIN);         //Create main window on the desktop
  IApplication::current().run();        //Get current application & start runnig
} /* end main */
