.*/*Ŀ*/
.*/*                                                                          */
.*/* PROGRAM NAME: MAHJONGG                                                   */
.*/* -------------                                                            */
.*/*  A PM version of a Chinese game similar to 'concentration' but without   */
.*/*  the background puzzle.                                                  */
.*/*                                                                          */
.*/* COPYRIGHT:                                                               */
.*/* ----------                                                               */
.*/*  Copyright (C) International Business Machines Corp., 1991,1992,1993.    */
.*/*                                                                          */
.*/* DISCLAIMER OF WARRANTIES:                                                */
.*/* -------------------------                                                */
.*/*  The following [enclosed] code is sample code created by IBM Corporation.*/
.*/*  This sample code is not part of any standard IBM product and is provided*/
.*/*  to you solely for the purpose of assisting you in the development of    */
.*/*  your applications.  The code is provided "AS IS", without warranty of   */
.*/*  any kind.  IBM shall not be liable for any damages arising out of your  */
.*/*  use of the sample code, even if they have been advised of the           */
.*/*  possibility of such damages.                                            */
.*/*                                                                          */
.*/* For details on what this program does etc., please see the MAHJONGG.C    */
.*/* file.                                                                    */
.*/*                                                                          */
.*/**/
.*
.*/*Ŀ*/
.*/* MAHJONGG.IPF                                                             */
.*/*                                                                          */
.*/* Mahjongg Game documentation (IPF) file                                   */
.*/**/
.*
#include "mahjongg.h"
:userdoc.
:title.Mahjongg Solitaire
:body.
.*--------------------------------------------------------
:h1 res(ID_WINDOW)Mahjongg
:p.
The :hp3.Mahjongg:ehp3. game presented here is a solitaire version
of a tile pair removing game.
:p.
The rest of this help material is organized as follows:
:ul.
:li.
:hp2.How to play Mahjongg:ehp2.
:ul compact.
:li.
:link reftype=hd res(IDM_HELP_PATIENCE)
Explanations and rules of the Mahjongg game
:elink.
:eul.
.*-------
:lp.
:li.
:hp2.Menus and Commands:ehp2.
:ul compact.
:li.
:link reftype=hd res(IDA_GAME)
Game
:elink.
:li.
:link reftype=hd res(IDA_MOVES)
Moves
:elink.
:li.
:link reftype=hd res(IDA_OPTIONS)
Options
:elink.
:li.
:link reftype=hd res(IDA_HELP)
Help
:elink.
:eul.
:eul.
.*--------------------------------------------------------
:h1 res(IDM_HELP_PATIENCE)How to Play the Game
:p.
:hp3.Mahjongg:ehp3. is an easy to play one person game with the following
rules:
:p.
:hp2.Objective&colon.:ehp2.
:p.
The objective of the game is to remove as many pairs of tiles as possible.
Tiles are always removed from the left or right edges of the pyramid.
Any tile that is not on a left or right edge is considered blocked and
cannot be removed. The pyramid consists of five levels of tiles. Tiles
which have another tile above them are blocked as well.
:p.
:hp2.Suits of tiles&colon.:ehp2.
:p.
There are different suits of tiles and for each suit there is a rule
how pairs can be matched. Tiles can only be matched when they are of the
same suit.
:p.
:hp3.Character Suit:ehp3.
:p.
:artwork name='tile_c_1.bmp' runin.
:artwork name='tile_c_2.bmp' runin.
:artwork name='tile_c_3.bmp' runin.
:artwork name='tile_c_4.bmp' runin.
:artwork name='tile_c_5.bmp' runin.
:artwork name='tile_c_6.bmp' runin.
:artwork name='tile_c_7.bmp' runin.
:artwork name='tile_c_8.bmp' runin.
:artwork name='tile_c_9.bmp' runin.
:p.
:hp3.Bamboo Suit:ehp3.
:p.
:artwork name='tile_b_1.bmp' runin.
:artwork name='tile_b_2.bmp' runin.
:artwork name='tile_b_3.bmp' runin.
:artwork name='tile_b_4.bmp' runin.
:artwork name='tile_b_5.bmp' runin.
:artwork name='tile_b_6.bmp' runin.
:artwork name='tile_b_7.bmp' runin.
:artwork name='tile_b_8.bmp' runin.
:artwork name='tile_b_9.bmp' runin.
:p.
:hp3.Dots Suit:ehp3.
:p.
:artwork name='tile_d_1.bmp' runin.
:artwork name='tile_d_2.bmp' runin.
:artwork name='tile_d_3.bmp' runin.
:artwork name='tile_d_4.bmp' runin.
:artwork name='tile_d_5.bmp' runin.
:artwork name='tile_d_6.bmp' runin.
:artwork name='tile_d_7.bmp' runin.
:artwork name='tile_d_8.bmp' runin.
:artwork name='tile_d_9.bmp' runin.
:p.
:hp3.Dragons Suit:ehp3.
:p.
:artwork name='tile_r_1.bmp' runin.
:artwork name='tile_r_2.bmp' runin.
:artwork name='tile_r_3.bmp' runin.
:p.
:hp3.Winds Suit:ehp3.
:p.
:artwork name='tile_w_e.bmp' runin.
:artwork name='tile_w_n.bmp' runin.
:artwork name='tile_w_w.bmp' runin.
:artwork name='tile_w_s.bmp' runin.
:note.That for the above 5 suits an exact match is required.
:p.
:hp3.Flowers Suit:ehp3.
:p.
:artwork name='tile_f_1.bmp' runin.
:artwork name='tile_f_2.bmp' runin.
:artwork name='tile_f_3.bmp' runin.
:artwork name='tile_f_4.bmp' runin.
:p.
:hp3.Seasons Suit:ehp3.
:p.
:artwork name='tile_s_1.bmp' runin.
:artwork name='tile_s_2.bmp' runin.
:artwork name='tile_s_3.bmp' runin.
:artwork name='tile_s_4.bmp' runin.
:note.That for the above 2 suits any tile matches any other tile in the same suit.
:p.
:hp2.Number of tiles&colon.:ehp2.
:p.
There are 144 tiles total: for the flower and seasons suits only one tile
of each exists, for all other suits four of each tile exist.
:p.
The game does not come out very often.
.*--------------------------------------------------------
:h1. Menus and Commands
:p.
The menus are ordered by the following main topics:
:ul compact.
:li.
:link reftype=hd res(IDA_GAME)
Game
:elink.
:li.
:link reftype=hd res(IDA_MOVES)
Moves
:elink.
:li.
:link reftype=hd res(IDA_OPTIONS)
Options
:elink.
:li.
:link reftype=hd res(IDA_HELP)
Help
:elink.
:eul.
.*--------------------------------------------------------
:h2 res(IDA_GAME) The Game Menu
:p.
The game menu contains choices to start a new (fresh dealt copy) game,
and to exit this program.
:ul compact.
:li.
:link reftype=hd res(IDM_NEW_G)
New (Deal)
:elink.
:li.
:link reftype=hd res(IDM_EXIT)
Exit
:elink.
:eul.
.*--------------------------------------------------------
:h3 res(IDM_NEW_G) New (Deal)
:p.Takes all tiles, shuffles and redistributes them.
Hence a new game is started.
.*--------------------------------------------------------
:h3 res(IDM_EXIT) Exit
:p.Quits this program.
.*--------------------------------------------------------
:h2 res(IDA_MOVES) The Moves Menu
:p.
The moves menu allows the editing of moves by either
undoing or redoing the last action, and showing all next possible moves.
:ul compact.
:li.
:link reftype=hd res(IDM_UNDO)
Tack Back
:elink.
:li.
:link reftype=hd res(IDM_REDO)
Replay
:elink.
:li.
:link reftype=hd res(IDM_SHOW)
Show next moves
:elink.
:eul.
.*--------------------------------------------------------
:h3 res(IDM_UNDO) Take Back the Previous Action
:p.
A rather large stack of the last user actions is kept by this program.  The
:hp2.Take Back:ehp2. choice will undo the most recent user action.  The
:hp2.Take Back:ehp2. command may repeated as many times as there are actions
on the :hp2.Take Back:ehp2. stack.  :hp2.Take Back:ehp2. actions may be redone
by the :link reftype=hd res(IDM_REDO)
Replay
:elink.
command.
.*--------------------------------------------------------
:h3 res(IDM_REDO) Replay the Last Take Back Action
:p.
:hp2.Replay:ehp2. re-executes the most recent :hp2.Take Back:ehp2. action on the
:link reftype=hd res(IDM_UNDO)
Take Back
:elink.
stack.
.*--------------------------------------------------------
:h3 res(IDM_SHOW) Show the Next Possible Moves
:p.
Each pair of tiles which could be removed as the next move
is highlighted during half a second. The intention is to give
some help on how to proceed.
:p.
When no more moves are possible a message box is displayed to inform
you about this fact.
.*--------------------------------------------------------
:h2 res(IDA_OPTIONS) The Options Menu
:p.
The options menu allows the setting of a warning sound for wrong
selections.  This value may be saved from this menu.
you.
:ul compact.
:li.
:link reftype=hd res(IDM_SOUND)
Sound Toggle
:elink.
:li.
:link reftype=hd res(IDM_SAVEOPT)
Save Options
:elink.
:eul.
.*--------------------------------------------------------
:h3 res(IDM_SOUND) Sound Toggle
:p.Toggles sound and warning beeps on or off.
.*--------------------------------------------------------
:h3 res(IDM_SAVEOPT) Save Options
:p.
The Options selectable in the options menu are saved in the OS2.INI file
and read back to be taken as defaults whenever a the Mahjongg Game is
started.  The saved values encompass only the sound setting currently.
.*--------------------------------------------------------
:h2 res(IDA_HELP) The Help Menu
:p.
The help menu contains choices for fast access to special sections of this
help information. The following choices are available:
:ul compact.
:li.
:link reftype=hd res(IDM_HELP_HELP)
Help for help
:elink.
:li.
:link reftype=hd res(IDM_HELP_EXTENDED)
Extended Help
:elink.
:li.
:link reftype=hd res(IDM_HELP_KEYS)
Keys Help
:elink.
:li.
:link reftype=hd res(IDM_HELP_INDEX)
Help Index
:elink.
:li.
:link reftype=hd res(IDM_ABOUT)
About
:elink.
:eul.
.*--------------------------------------------------------
:h3 res(IDM_HELP_HELP) Help for help
:p.
Explains how to use the help facility.
.*--------------------------------------------------------
:h3 res(IDM_HELP_EXTENDED) Extended help
:p.
Explains the working of this program, its options and how to play Mahjongg.
.*--------------------------------------------------------
:h3 res(IDM_HELP_KEYS) Help for Keys
:p.
:dl.
:dt.Ctrl+N
:dd.Accelerator for :hp3.New (Deal):ehp3.
:dt.Ctrl+R
:dd.Accelerator for :hp3.Replay:ehp3.
:dt.Ctrl+S
:dd.Accelerator for :hp3.Show:ehp3.
:dt.Ctrl+T
:dd.Accelerator for :hp3.Take Back:ehp3.
:dt.F1
:dd.Accelerator for :hp3.Get help about this program:ehp3.
:dt.F3
:dd.Accelerator for :hp3.Exit this program:ehp3.
:dt.Alt + Backspace
:dd.The standard accelerator for :hp3.Take Back:ehp3.
:edl.
.*--------------------------------------------------------
:h3 res(IDM_HELP_INDEX) Index to the Help Topics
:P.
Displays the index to the help topics
.*--------------------------------------------------------
:h3 res(IDM_ABOUT) About Mahjongg
:p.
This choice shows a panel with the game&apos.s copyright, its
version and name.
:euserdoc.
.*--- end ------------------------------------------------
